unit brown;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids, ColorBtns, ExtCtrls, math;

type
  Tfbrown = class(TForm)
    BitBtn1: TBitBtn;
    StringGrid1: TStringGrid;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    StringGrid2: TStringGrid;
    Label1: TLabel;
    BitBtn5: TBitBtn;
    Panel1: TPanel;
    StringGrid3: TStringGrid;
    Color95Button1: TColor95Button;
    Color95Button2: TColor95Button;
    Label4: TLabel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    Memo2: TMemo;
    procedure initialise(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure edit_print(Sender: TObject);
    procedure reset(Sender: TObject);
    procedure exporte_cif(Sender: TObject);
    procedure peint_grille3(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure click_cellule(Sender: TObject);
    procedure selecte_cellule(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure Color95Button1Click(Sender: TObject);
    procedure Color95Button2Click(Sender: TObject);
    procedure peint_grid2(Sender: TObject; Col, Row: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure RadioGroup1Click(Sender: TObject);
    procedure init_crea(Sender: TObject);
    procedure StringGrid2Click(Sender: TObject);
    procedure ferme(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fbrown: Tfbrown;
  nb_lignes_brown   : integer;

implementation

{$R *.DFM}
uses
  oemath, mainmenu, get_sp, formula;

type
  vois = record
    nom           : string[6];
    code          : string[15];
    num,x,y,z     : integer;
    dist          : double;
end;

var
  voisins                                      : array[1..1000] of atomes;
  nb_voisins,acol,arow                         : integer;
  pivot                                        : atomes;
  element_voisin,element_pivot                 : string[2];
  distance_max                                 : double;
  //Type de liaisons pour Brown (les types ne sont pas changs pour Gretep)
  tableau_liai2                            : array[1..1000] of typ_liaisons;
  nb_typ_liai2                             : integer;

procedure clear_fenetre;
//----------------------
begin
  fbrown.memo2.clear;
  nb_voisins:=0;
  nb_lignes_brown:=0;
end;

procedure lit_bonds;
//------------------
var
   i,ier              : integer;
   s                  : string;
   x                  : double;
begin
  for i:=1 to nb_typ_liai2 do begin
    s:=fbrown.stringGrid2.cells[2,i];
    val(s,x,ier);
    if (ier > 0)then begin
      erreur('Read error at line '+inttostr(i));
      exit;
    end;
    tableau_liai2[i].distance:=x;
  end;
end;

procedure Tfbrown.initialise(Sender: TObject);
//--------------------------------------------
var
  i,j,k             : integer;
  s,s1              : string;
  s2,c2             : string;
begin
  left:=0;
  top:=0;
  nb_lignes_brown:=0;

//stringgrid3 (asymetric contents)
  stringgrid3.rowcount:=nb_motif+2;
  stringgrid3.colwidths[0]:=30 ;
  if (nb_motif < 14)then stringgrid3.colwidths[4]:=40 else stringgrid3.colwidths[4]:=20;
  stringgrid3.cells[0,0]:='Atom';
  stringgrid3.cells[1,0]:='X';
  stringgrid3.cells[2,0]:='Y';
  stringgrid3.cells[3,0]:='Z';
  stringgrid3.cells[4,0]:='Sel';
  stringgrid3.Cells[4,1]:='*';
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      s:=nom;
      stringgrid3.cells[0,i]:=s;
      str(x:8:4,s1);
      stringgrid3.cells[1,i]:=s1;
      str(y:8:4,s1);
      stringgrid3.cells[2,i]:=s1;
      str(z:8:4,s1);
      stringgrid3.cells[3,i]:=s1;
    end;
  end;
  stringgrid3.Cells[0,1]:=motif[1].nom;

//StringGrid1 (positions quivalentes)
  if (npos < 28)then stringGrid1.Defaultcolwidth:=66 else stringGrid1.Defaultcolwidth:=61;
  stringgrid1.colwidths[0]:=25 ;
  stringgrid1.rowcount:=fmainmenu.stringgrid1.rowcount;
  stringgrid1.colcount:=fmainmenu.stringgrid1.colcount-1;
  with StringGrid1 do begin
    for i:=0 to rowcount-1 do begin
      for j:=0 to colcount-1 do begin
        cells[j,i]:=lowercase(fmainmenu.stringgrid1.cells[j,i]);
      end;
    end;
  end;

//StringGrid2: types de liaison
    StringGrid2.cells[0,0]:='At1';
    StringGrid2.cells[1,0]:='At2';
    StringGrid2.cells[2,0]:='D Max.';
    nb_typ_liai2:=nb_typ_liai;
    for i:=1 to nb_typ_liai do begin
      tableau_liai2[i]:=tableau_liai[i];
      with tableau_liai[i] do begin
        s2:=trim(atome1);
        c2:=lowercase(s2);
        if (length(s2) = 2)then s2[2]:=c2[2];
        StringGrid2.cells[0,i]:=s2;
        s2:=trim(atome2);
        c2:=lowercase(s2);
        if (length(s2) = 2)then s2[2]:=c2[2];
        StringGrid2.cells[1,i]:=s2;
        str(distance:6:2,s);
        StringGrid2.cells[2,i]:=s;
      end;
  end;

end;

procedure code_positions(var j,i1,i2,i3,i4,ixt,iyt,izt: integer);
//--------------------------------------------------------------
  var
    i,ix,iy,iz,no_motif                     : integer;
    x0,y0,z0,x1,y1,z1,x_at,y_at,z_at        : real;
    name,s                                  : string;
begin
  name:='';
  i1:=0;
  i2:=0;
  i3:=0;
  i4:=0;
  no_motif:=0;
  with voisins[j] do begin
    x_at:=x+ixt;
    y_at:=y+iyt;
    z_at:=z+izt;
    s:=nom;traite_nom_atome(s);name:=uppercase(s);
  end;
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      s:=nom;traite_nom_atome(s);s:=uppercase(s);
      if (name = s) then begin
        no_motif:=i;
        break;
      end;
    end;
  end;
  if (no_motif = 0)then begin
    erreur(name+' not decoded');
    exit;
  end;
  for i:=1 to npos do begin
     with motif[no_motif] do begin
       x0:=tp[i,1,4]+x*tp[i,1,1]+y*tp[i,1,2]+z*tp[i,1,3];
       y0:=tp[i,2,4]+x*tp[i,2,1]+y*tp[i,2,2]+z*tp[i,2,3];
       z0:=tp[i,3,4]+x*tp[i,3,1]+y*tp[i,3,2]+z*tp[i,3,3];
     end;
     for ix:=-3 to 3 do begin
       for iy:=-3 to 3 do begin
         for iz:=-3 to 3 do begin
           x1:=x0+ix;
           y1:=y0+iy;
           z1:=z0+iz;
           if (abs(x1-x_at) < 0.001) and
              (abs(y1-y_at) < 0.001) and
              (abs(z1-z_at) < 0.001) then begin
             i1:=i;
             i2:=5+ix;
             i3:=5+iy;
             i4:=5+iz;
             exit;
           end;
         end;
       end;
     end;
  end;
end;

procedure blanc (var s:string; n:integer);
//----------------------------------------
var i :integer;
begin
  if (length(s) < n)then for i:=length(s) to n do s:=s+' ';
end;

Procedure calcule_coordinance;
//---------------------------
var
  s2                                           : string[2];
  s,s1,ss                                      : string;
  chaine,chaine2                               : string;
  i,j,k,ier,ix,iy,iz,i1,i2,i3,i4,nb_coord      : integer;
  jx,jy,jz                                     : integer;
  distance                                     : double;
  xx1,yy1,zz1,xx2,yy2,zz2,xx3,yy3,zz3          : double;
  nomf    : textfile;
  at               : array[1..50] of vois;
  d3,d2,angle      : double;

begin

//Recherche des voisins possibles
   nb_voisins:=0;
   for i:=1 to nb_motif do begin
     s2:=trim(motif[i].element);
     if (s2 =  element_voisin)then begin
       for j:=1 to npos do begin
         nb_voisins:=nb_voisins+1;
         voisins[nb_voisins]:=motif[i];
         with motif[i] do begin
           voisins[nb_voisins].x:=tp[j,1,4]+x*tp[j,1,1]+y*tp[j,1,2]+z*tp[j,1,3];
           voisins[nb_voisins].y:=tp[j,2,4]+x*tp[j,2,1]+y*tp[j,2,2]+z*tp[j,2,3];
           voisins[nb_voisins].z:=tp[j,3,4]+x*tp[j,3,1]+y*tp[j,3,2]+z*tp[j,3,3];
         end;
       end;
     end;
   end;

//Remise dans la maille
   for i:=1 to nb_voisins do begin
     with voisins[i] do begin
       if (x < 0)then x:=x+1;x:=frac(x);
       if (y < 0)then y:=y+1;y:=frac(y);
       if (z < 0)then z:=z+1;z:=frac(z);
     end;
   end;

//Doubles?
   for i:= 1 to nb_voisins-1 do begin
     if (voisins[i].nom = '')then continue;
     for j:=i+1 to nb_voisins do begin
       if (abs(voisins[i].x-voisins[j].x) < 0.001) and
          (abs(voisins[i].y-voisins[j].y) < 0.001) and
          (abs(voisins[i].z-voisins[j].z) < 0.001) then voisins[j].nom:='';
     end;
   end;

//Compression
   j:=0;
   for i:=1 to nb_voisins do begin
     if (voisins[i].nom = '')then continue;
     j:=j+1;
     voisins[j]:=voisins[i];
     with voisins[j] do begin
       str(j:3,s);
       s:=s+' '+nom+' ';
       str(x:8:4,s1);
       s:=s+s1;
       str(y:8:4,s1);
       s:=s+s1;
       str(z:8:4,s1);
       s:=s+s1;
     end;
   end;
   nb_voisins:=j;

//Distances
   xx1:=pivot.x;
   yy1:=pivot.y;
   zz1:=pivot.z;

   nb_coord:=0;
   for i:=1 to nb_voisins do begin
     for ix:=-1 to 1 do begin
       xx2:=voisins[i].x+ix;
       for iy:=-1 to 1 do begin
         yy2:=voisins[i].y+iy;
         for iz:=-1 to 1 do begin
           zz2:=voisins[i].z+iz;
           xx3:=xx2-xx1;
           yy3:=yy2-yy1;
           zz3:=zz2-zz1;
           trfo2(xx3,yy3,zz3,r20);
           distance:=sqrt(sqr(xx3)+sqr(yy3)+sqr(zz3));
           if (distance < 0.01)then continue;
           if (distance <= distance_max)then begin
             nb_coord:=nb_coord+1;
             if (nb_coord = 1)then begin
               fbrown.memo2.lines.add(' ');
               nb_lignes_brown:=nb_lignes_brown+1;
             end;
             s:=pivot.nom+' ';
             blanc(s,5);
             s1:=voisins[i].nom;
             blanc(s1,4);
             s:=s+s1;
             str(distance:6:3,s1);
             s:=s+s1;
             j:=i;
             jx:=ix;jy:=iy;jz:=iz;
             code_positions(j,i1,i2,i3,i4,jx,jy,jz);
             chaine2:=' ('+s_pos[i1];
             blanc(chaine2,25);
             s:=s+chaine2;
             chaine:=') ('+inttostr(i1)+'_'+inttostr(i2)+
             inttostr(i3)+inttostr(i4)+')';
             blanc(chaine,11);
             s:=s+chaine;
             with voisins[i] do begin
               str(x+ix:8:4,s1);
               s:=s+s1;
               str(y+iy:8:4,s1);
               s:=s+s1;
               str(z+iz:8:4,s1);
               s:=s+s1;
             end;
             fbrown.memo2.lines.add(s);
             nb_lignes_brown:=nb_lignes_brown+1;

             with at[nb_coord] do begin
               nom:=voisins[i].nom;
               code:=copy(chaine,2,length(chaine)-2);
               num:=i;
               x:=ix;
               y:=iy;
               z:=iz;
               dist:=distance;
             end;

           end;
         end;
       end;
     end;
   end;

   if (nb_coord > 1) and (fbrown.radiogroup1.itemIndex = 1)then begin
     fbrown.memo2.lines.add('');
     nb_lignes_brown:=nb_lignes_brown+1;
     xx1:=pivot.x;
     yy1:=pivot.y;
     zz1:=pivot.z;
     for i:=1 to nb_coord-1 do begin
       k:=at[i].num;
       xx2:=voisins[k].x+at[i].x-xx1;
       yy2:=voisins[k].y+at[i].y-yy1;
       zz2:=voisins[k].z+at[i].z-zz1;
       trfo2(xx2,yy2,zz2,r20);
       d2:=sqr(xx2)+sqr(yy2)+sqr(zz2);
       d2:=sqrt(d2);
       for j:=i+1 to nb_coord do begin
         k:=at[j].num;
         xx3:=voisins[k].x+at[j].x-xx1;
         yy3:=voisins[k].y+at[j].y-yy1;
         zz3:=voisins[k].z+at[j].z-zz1;
         trfo2(xx3,yy3,zz3,r20);
         d3:=sqr(xx3)+sqr(yy3)+sqr(zz3);
         d3:=sqrt(d3);
         angle:=57.2957*arccos((xx2*xx3+yy2*yy3+zz2*zz3)/(d2*d3));

         s:=' Angle: ';

         s1:=trim(at[i].nom);blanc(s1,5);
         s:=s+s1;

         s1:=trim(pivot.nom);blanc(s1,5);
         s:=s+s1;

         s1:=trim(at[j].nom);blanc(s1,5);
         s:=s+s1;

         str(angle:7:2,s1);blanc(s1,7);
         s:=s+s1;

         s1:=trim(at[i].code);blanc(s1,8);
         s:=s+'   '+s1+ '  (1_555)  ';

         s1:=trim(at[j].code);blanc(s1,8);
         s:=s+s1;

         fbrown.memo2.lines.add(s);
         nb_lignes_brown:=nb_lignes_brown+1;
       end;
     end;
   end;
end;

procedure Tfbrown.Button1Click(Sender: TObject);
//----------------------------------------------
var
  s2,element_pivot                                           : string[2];
  i_element1,i_element2,i_motif,i_liaison                      : integer;
  s,s1                                         : string;
  i,j,k,ier,ix,iy,iz,i1,i2,i3,i4               : integer;
  distance                                     : double;
  xx1,yy1,zz1,xx2,yy2,zz2,xx3,yy3,zz3          : double;
  nomf    : textfile;
begin
  memo2.clear;
  nb_lignes_brown:=0;
  flag_brown:=1;
  lit_bonds;
  for i_element1:=1 to nb_typ_element do begin
    element_pivot:=element[i_element1].nom;
    for i_motif:=1 to nb_motif do begin
      s:=stringgrid3.Cells[4,i_motif];
      s:=trim(s);
      if (s <>'*')then continue;
      if (element_pivot <> motif[i_motif].element) then continue;
      pivot:=motif[i_motif];
      for i_element2:=1 to nb_typ_element do begin
        element_voisin:=element[i_element2].nom;
        for i_liaison:=1 to nb_typ_liai2 do begin
          if ((tableau_liai2[i_liaison].atome1 = element_pivot)
          and (tableau_liai2[i_liaison].atome2 = element_voisin))
          or ((tableau_liai2[i_liaison].atome2 = element_pivot)
          and (tableau_liai2[i_liaison].atome1 = element_voisin))then begin
            distance_max:=tableau_liai2[i_liaison].distance;
            if (distance_max < 0.001)then continue;
            calcule_coordinance;
          end;
        end;
      end;
    end;
  end;

end;

procedure Tfbrown.sortie(Sender: TObject);
//-----------------------------------------
begin
  flag_brown:=0;
  close;
end;

procedure Tfbrown.edit_print(Sender: TObject);
//----------------------------------------------
var
   CmdFile           : PChar;
   i                 : integer;
   nomf              : textfile;
   s                 : string;
begin
  if (nb_lignes_brown = 0)then exit;
  assignFile(nomf,'dist.txt');
  rewrite(nomf);
  for i:=0 to nb_lignes_brown-1 do begin
    s:=memo2.lines[i];
    writeln(nomf,s);
  end;
  closefile(nomf);
  CmdFile:='write.exe dist.txt';
  i:=WinExec(CmdFile,5);
end;

procedure Tfbrown.reset(Sender: TObject);
//---------------------------------------
begin
  memo2.clear;
  nb_lignes_brown:=0;
end;

procedure Tfbrown.exporte_cif(Sender: TObject);
//----------------------------------------------
begin
  fformula.radiogroup1.visible:=false;
  fformula.label2.visible:=false;
  if (nb_lignes_brown = 0)then exit;
  if (nb_motif = 0)then exit;
  if (groupe_espace = '')then begin
    beep;
    fget_sp.visible:=true;
    exit;
  end;
  go_save_cif;
end;

procedure Tfbrown.peint_grille3(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------
var
  s             : string;
  posx          : integer;
begin
//Changement de couleur si la position est slectionne
  if (col= 0)and (row = 1) then exit;
  s:=trim(Stringgrid3.cells[4,row]);
  if (s = '*') and (col = 4) then begin
    stringgrid3.canvas.brush.color:=$F3D1FF;
    stringgrid3.canvas.fillrect(rect);
    stringgrid3.canvas.font.color:=clblack;
    stringgrid3.canvas.textout(rect.left+2,rect.top+2,stringgrid3.cells[col,row]);
  end else stringgrid3.canvas.brush.color:=clwhite;
  s:=stringgrid3.cells[col,row];
//centrage de la chaine
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid3.canvas.textWidth(s)) div 2;
  stringgrid3.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfbrown.click_cellule(Sender: TObject);
//-----------------------------------------------
var
  s          : string;
begin
   clear_fenetre;
   if (acol <> 4)then exit;
   s:=stringgrid3.cells[acol,arow];
   if (s = '') then s:='*' else s:='';
   stringgrid3.cells[acol,arow]:=s;
end;

procedure Tfbrown.selecte_cellule(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//--------------------------------------------------------------------
begin
   arow:=row;
   acol:=col;
end;

procedure Tfbrown.Color95Button1Click(Sender: TObject);
//-----------------------------------------------------
var
  i       : integer;
begin
  for i:=1 to nb_motif do stringGrid3.cells[4,i]:='*';
end;

procedure Tfbrown.Color95Button2Click(Sender: TObject);
//-----------------------------------------------------
var
  i       : integer;
begin
  for i:=2 to nb_motif do stringgrid3.cells[4,i]:='';
end;

procedure Tfbrown.peint_grid2(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//---------------------------------------------------------------
var
  s             : string;
  posx          : integer;
begin
  s:=stringgrid2.cells[col,row];
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid2.canvas.textWidth(s)) div 2;
  stringgrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfbrown.RadioGroup1Click(Sender: TObject);
//--------------------------------------------------
begin
  clear_fenetre;
  if (radiogroup1.itemIndex= 0)then label2.caption:='Distances'
  else label2.caption:='Angles and Distances'
end;

procedure Tfbrown.init_crea(Sender: TObject);
begin

if (screen.Width = 800)then begin
  with fbrown do begin
    Left := 0;  Top := 0;  Width := 812;  Height := 580;
  end;
  with Label2 do begin
    Left := 324;     Top := 64;    Width := 96;    Height := 13;
  end;
  with Label3 do begin
    Left := 816;    Top := 64;    Width := 120;    Height := 16;
  end;
  with Label1 do begin
    Left := 56;     Top := 412;     Width := 84;     Height := 13;
  end;
  with Label4 do begin
    Left := 48;    Top := 64;    Width := 89;    Height := 13;
  end;
  with BitBtn1 do begin
    Left := 289;    Top := 2;    Width := 97;    Height := 25
  end;
  with StringGrid1 do begin
    Left := 599;    Top := 80;    Width := 235;    Height := 468;
  end;
  with BitBtn2 do begin
    Left := 0;    Top := 2;    Width := 97;    Height := 25;
  end;
  with BitBtn3 do begin
    Left := 96;    Top := 2;    Width := 97;    Height := 25;
  end;
  with StringGrid2 do begin
    Left := 30;    Top := 428;    Width := 145;    Height := 129;
  end;
  with BitBtn5 do begin
    Left := 192;    Top := 2;    Width := 97;    Height := 25;
    Hint := 'Edit the results (and print)'
  end;
  with Panel1 do begin
    Left := 0;    Top := 80;    Width := 201;    Height := 325;
  end;
  with Color95Button1 do begin
      Left := 4;      Top := 292;      Width := 81;      Height := 25;
  end;
  with Color95Button2 do begin
      Left := 88;      Top := 292;      Width := 81;      Height := 25;
  end;
  with StringGrid3 do begin
      Left := 2;      Top := 16;      Width := 191;      Height := 273;
      DefaultColWidth := 40;
      DefaultRowHeight := 18;
      FixedCols := 0;
      RowCount := 30;
      Font.Charset := ANSI_CHARSET;
      Font.Color := clWindowText;
      Font.Height := -11;
      Font.Name := 'MS Serif';
      Font.Style := [];
  end;
  with Memo1 do begin
    Left := 456;    Top := 0;    Width := 321;    Height := 45;
  end;
  with RadioGroup1 do begin
    Left := 0;    Top := 26;    Width := 281;    Height := 30;
  end;
  with Memo2 do begin
    Left := 200;    Top := 80;    Width := 397;    Height := 465;
  end;
end;
end;

procedure Tfbrown.StringGrid2Click(Sender: TObject);
//--------------------------------------------------
begin
   clear_fenetre;
end;

procedure Tfbrown.ferme(Sender: TObject; var Action: TCloseAction);
//-----------------------------------------------------------------
begin
   clear_fenetre;
end;

end.
