unit disp_distances;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Grids;

type
  Tfdistances = class(TForm)
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure sortie(Sender: TObject);
    procedure affiche(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure peint_grid1(Sender: TObject; Col, Row: Integer; Rect: TRect;
      State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fdistances: Tfdistances;

implementation

{$R *.DFM}

uses
  oemath,digicode;

procedure Tfdistances.sortie(Sender: TObject);
//--------------------------------------------
begin
  if fileexists('distances.txt') then deletefile('distances.txt');
  close;
end;

procedure Tfdistances.affiche(Sender: TObject);
//--------------------------------------------
var
  i,i1,i2,i3,i4                     : integer;
  s                                 : string;
begin
  with stringGrid1 do begin
    colwidths[0]:=30;
    colwidths[5]:=30;
    colwidths[4]:=150;
    colwidths[9]:=150;
    cells[0,0]:='Atom';
    cells[1,0]:='X';
    cells[2,0]:='Y';
    cells[3,0]:='Z';
    cells[4,0]:='Position';
    cells[5,0]:='Atom';
    cells[6,0]:='X';
    cells[7,0]:='Y';
    cells[8,0]:='Z';
    cells[9,0]:='Position';
    cells[10,0]:='Distance';
    for i:=1 to nb_bonds do begin
      with bonds[i] do begin
        s:=child[atome1].nom;
        traite_nom_atome(s);
        cells[0,i]:=s;
        str(child[atome1].x:7:4,s);
        cells[1,i]:=s;
        str(child[atome1].y:7:4,s);
        cells[2,i]:=s;
        str(child[atome1].z:7:4,s);
        cells[3,i]:=s;
        code_positions(atome1,i1,i2,i3,i4);
        s:=' ('+s_pos[i1]+') ('+inttostr(i1)+'_'+inttostr(i2)+inttostr(i3)+
        inttostr(i4)+')';
        cells[4,i]:=s;

        s:=child[atome2].nom;
        traite_nom_atome(s);
        cells[5,i]:=s;
        str(child[atome2].x:7:4,s);
        cells[6,i]:=s;
        str(child[atome2].y:7:4,s);
        cells[7,i]:=s;
        str(child[atome2].z:7:4,s);
        cells[8,i]:=s;
        code_positions(atome2,i1,i2,i3,i4);
        s:=' ('+s_pos[i1]+') ('+inttostr(i1)+'_'+inttostr(i2)+inttostr(i3)+
        inttostr(i4)+')';
        cells[9,i]:=s;

        str(distance:7:3,s);
        cells[10,i]:=s;
      end;
    end;
  end;
end;

procedure Tfdistances.BitBtn2Click(Sender: TObject);
//--------------------------------------------------
var
   CmdFile           : PChar;
   i                 : integer;
   nomf              : Textfile;
   s1,s2             : string[4];
   s                 : string;
begin
   assignfile (nomf,repertoire_origine+'/distances.txt');
   rewrite(nomf);
   if (nom_fichier_shelx <> '')then writeln(nomf,extractfilename(nom_fichier_shelx));
   if (nom_fichier_grt <> '')then writeln(nomf,extractfilename(nom_fichier_grt));
   Writeln(nomf,'  A1    A2     dist.   x1     y1     z1     x2     y2     z2');

   for i:=1 to nb_bonds do begin
     with bonds[i] do begin
       s:=child[atome1].nom;
       traite_nom_atome(s);s1:=trim(s);
       s:=child[atome2].nom;
       traite_nom_atome(s);s2:=trim(s);
       writeln(nomf,s1:4,' -',s2:4,distance:9:3,' ',
       child[atome1].x:7:4,child[atome1].y:7:4,child[atome1].z:7:4,
       child[atome2].x:7:4,child[atome2].y:7:4,child[atome2].z:7:4,
       ' ',stringgrid1.cells[4,i],
       ' ',stringgrid1.cells[9,i]);
     end;
   end;
   closefile(nomf);
   CmdFile:='write.exe distances.txt';
   i:=WinExec(CmdFile,5);
end;

procedure Tfdistances.peint_grid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
var
  s             : string;
  posx          : integer;
begin
  with stringgrid1.canvas do begin
    s:=stringgrid1.cells[col,row];
    posx:= ((Rect.right-rect.left-2)-textWidth(s)) div 2;
    textrect(rect,rect.left+posx,rect.top,s);
  end;
end;


end.
