unit disp_posi;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons;

type
  Tfposi = class(TForm)
    BitBtn1: TBitBtn;
    Button1: TButton;
    Memo1: TMemo;
    StringGrid2: TStringGrid;
    Button2: TButton;
    procedure init(Sender: TObject);
    procedure peint(Sender: TObject; Col, Row: Longint; Rect: TRect;
      State: TGridDrawState);
    procedure select_cell(Sender: TObject; Col, Row: Longint;
      var CanSelect: Boolean);
    procedure selecte_tout(Sender: TObject);
    procedure sortie(Sender: TObject);
    procedure onclick(Sender: TObject);
    procedure deselecte_tout(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  fposi: Tfposi;

implementation

{$R *.DFM}
uses
  oemath,fichiers, mainmenu;
var
    acol,arow  : integer;

procedure Tfposi.init(Sender: TObject);
//-----------------------------------------
var
 s               : string;
 i,j,k           : integer;
 v4              : vecteur4;
begin
  with StringGrid2 do begin
    colwidths[0]:=20;
    colwidths[4]:=50;
    cells[0,0]:='Nb';
    cells[1,0]:='a';
    cells[2,0]:='b';
    cells[3,0]:='c';
    cells[4,0]:='Selected';

    if (npos = 0)then exit;
    for i:=1 to rowcount-1 do
      for j:=0 to 4 do cells[j,i]:='';

    for i:=1 to npos do begin
      str(i:3,s);
      cells[0,i]:=inttostr(i);
      for j:=1 to 3 do begin
        for k:=1 to 4 do v4[k]:=tp[i,j,k];
        code(v4,s);
        s:=uppercase(s);
        cells[j,i]:=s;
      end;
      if (selected[i] = 1)then cells[4,i]:= '*';
    end;
  end;
 // stringgrid1.refresh;
end;

procedure Tfposi.peint(Sender: TObject; Col, Row: Longint;
  Rect: TRect; State: TGridDrawState);
//-------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  //Changement de couleur si la position est slectionne
  s:=trim(StringGrid2.cells[4,row]);
  if (s = '*') and (col = 4) then begin
    stringgrid2.canvas.brush.color:=$EECBFF;
    stringgrid2.canvas.fillrect(rect);
    stringgrid2.canvas.font.color:=clblack;
    stringgrid2.canvas.textout(rect.left+2,rect.top+2,stringgrid2.cells[col,row]);
  end else stringgrid2.canvas.brush.color:=clwhite;
  s:=stringgrid2.cells[col,row];
  //On numrote si le numro est absent
  if (col > 0) and (stringGrid2.cells[0,row] = '') and
  (stringGrid2.cells[1,row] <> '')then
  stringGrid2.cells[0,row]:=inttostr(row);
  //centrage
  if (row > 0)then s:=upperCase(s);
  posx:= ((Rect.right-rect.left-2)-stringgrid2.canvas.textWidth(s)) div 2;
  stringgrid2.canvas.textrect(rect,rect.left+posx,rect.top,s);
end;

procedure Tfposi.selecte_tout(Sender: TObject);
//-------------------------------------------------
var
  i           : integer;
begin
   with stringgrid2 do begin
     for i:=1 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='*';
     end;
   end;
end;

procedure relit_positions_selectionnees;
//--------------------------------------
var
   s,s1                : string;
   i,j,k,ier           : integer;
   x1,x2               : double;
   //nomf                : textfile;
const
   cod  : array[1..8] of string[20] =('Y-X','X-Y','-Z','-Y','-X','Z','Y','X');
   xn   : array[1..8] of integer = (-1, 1, 0, 0,-1, 0, 0, 1);
   yn   : array[1..8] of integer = ( 1,-1, 0,-1, 0, 0, 1, 0);
   zn   : array[1..8] of integer = ( 0, 0,-1, 0, 0, 1, 0, 0);
begin
  npos_sel:=0;
  //assignfile(nomf,'toto.esp');
  //rewrite(nomf);
  with fposi.stringgrid2 do begin
    //ligne i
    for i:=1 to rowcount-1 do begin
      s:=cells[1,i];s:=trim(s);
      //write(nomf,'ligne:',i,'  s',s);
      if (s = '')then break;
      if (cells[4,i] <> '*')then begin
        selected[i]:=0;
        continue;
      end;
      npos_sel:=npos_sel+1;
      selected[i]:=1;
      //colonne j
      for j:=1 to 3 do begin
        s:=cells[j,i];
        //writeln(nomf,' colonne: ',j,s);
        s:=trim(s);
        s:=UpperCase(s);
        for k:=1 to 8 do begin
          if (pos(cod[k],s) > 0)then begin
            tp_sel[npos_sel,j,1]:=xn[k];
            tp_sel[npos_sel,j,2]:=yn[k];
            tp_sel[npos_sel,j,3]:=zn[k];
            delete(s,pos(cod[k],s),length(cod[k]));
            s:=trim(s);
            break;
          end;
        end;
        ier:=0;
        while (pos('+',s) > 0)do s[pos('+',s)]:=' ';s:=trim(s);
        if (s = '')then begin
          tp_sel[npos_sel,j,4]:=0;
          continue;
        end;
        //s:=trim(s);
        if (pos('/',s) = 0)then begin
          val(s,tp_sel[npos_sel,j,4],ier);
        end else begin
          s1:=copy(s,1,pos('/',s)-1);
          val(s1,x1,ier);
          delete(s,1,pos('/',s));
          val(s,x2,ier);
          tp_sel[npos_sel,j,4]:=x1/x2;
        end;
        if (ier > 0)then begin
            erreur('Decoding Error!');
            exit;
        end;
      end;
    end;
  end;
  //closefile(nomf);
end;

procedure Tfposi.select_cell(Sender: TObject; Col, Row: Longint;
  var CanSelect: Boolean);
//------------------------------------------------------------------
begin
   arow:=row;
   acol:=col;
end;

procedure Tfposi.sortie(Sender: TObject);
//--------------------------------------------
//var
  //nomf    : textfile;
  //i,j     : integer;
begin
  relit_positions_selectionnees;
  //AssignFile(nomf,'pos.esp');
  //rewrite(nomf);
  (*for i:=1 to npos_sel do begin
     for j:=1 to 3 do
     writeln(nomf,tp_sel[i,j,1]:3:0,tp_sel[i,j,2]:3:0,tp_sel[i,j,3]:3:0,
     tp_sel[i,j,4]:8:5);
     writeln(nomf);
  end; *)
  //closefile(nomf);
  fposi.visible:=false;
end;

procedure Tfposi.onclick(Sender: TObject);
//----------------------------------------
var s:string;
begin
   if (acol <> 4)then exit;
   s:=stringgrid2.cells[acol,arow];
   if (s = '') then s:='*' else s:='';
   stringgrid2.cells[acol,arow]:=s;
end;


procedure Tfposi.deselecte_tout(Sender: TObject);
//----------------------------------------------
var  i:integer;
begin
     with stringgrid2 do begin
     for i:=2 to rowcount do begin
       if (cells[1,i] = '')then break;
       cells[4,i]:='';
     end;
   end;
end;

end.
