unit effaceE;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, ColorBtns;

type
  TfeffaceE = class(TForm)
    Panel1: TPanel;
    StringGrid1: TStringGrid;
    Memo1: TMemo;
    Color95Button2: TColor95Button;
    procedure initialise(Sender: TObject);
    procedure selecte_elem_todel(Sender: TObject; Col, Row: Integer;
      var CanSelect: Boolean);
    procedure del_elem_system(Sender: TObject);
    procedure peint_stringgrid1(Sender: TObject; Col, Row: Integer;
      Rect: TRect; State: TGridDrawState);
     procedure onclic(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  feffaceE: TfeffaceE;

implementation

{$R *.DFM}

uses
  oemath,paneau1;
var
  arow1,acol1                     : integer;

procedure TfeffaceE.initialise(Sender: TObject);
//---------------------------------------------
var
   i                 : integer;
begin
  with stringgrid1 do begin
   rowcount:=nb_typ_element+2;
   height:=21*rowcount;
   if(height > 425)then height:=425;
   for i:=0 to rowcount-1 do begin
       cells[0,i]:='';
       cells[1,i]:='';
    end;
    cells[0,0]:='Nb';
    cells[1,0]:='Elem.';
    cells[2,0]:='Sel.';
    for i:=1 to nb_typ_element do cells[0,i]:=element[i].nom;
  end;
 end;

procedure TfeffaceE.selecte_elem_todel(Sender: TObject; Col, Row: Integer;
  var CanSelect: Boolean);
//-----------------------------------------------------------------------
begin
  arow1:=row;
  acol1:=col;
end;

procedure TfeffaceE.del_elem_system(Sender: TObject);
//------------------------------------------------
var
  s                    : string;
  s2                   : string[2];
  i,j,ier,n            : integer;

  atdel                : array [1..2000] of ^atomes;
  elem_to_del          : array[1..10] of string[2];
  nb_to_del            : integer;
  w                    : word;
begin

  n:=0;
  for i:=1 to nb_typ_element do begin
    s:=stringgrid1.cells[0,i];
    if (pos('*',s) = 0) then continue;
    n:=n+1;
  end;
  if (n = 0)then begin
    feffaceE.visible:=false;
    exit;
  end;

//Message
  beep;
  s:='Are you sure to want to systematicaly delete the selected types of atom?';
  w:=messageDlg(s,mtConfirmation,mbYesNoCancel,0);
  if (w = mrNo) or (w = mrAbort) then exit;

//Slection des lements  effacer
  nb_to_del:=0;
  with stringGrid1 do begin
    n:=nb_typ_element;
    for i:=1 to n do begin
      s:=cells[0,i];
      if (pos('*',s) = 0) then continue else delete(s,pos('*',s),1);
      s:=trim(s);
      ier:=0;
      nb_to_del:=nb_to_del+1;
      elem_to_del[nb_to_del]:=s;
      for j:= 1 to nb_typ_element do begin
        if (s = element[j].nom) then begin
          ier:=j;
          break;
        end;
      end;
      if (ier > 0)then begin
        if (ier < nb_typ_element)then
        for j:=ier+1 to nb_typ_element do element[j-1]:=element[j];
        nb_typ_element:=nb_typ_element-1;
      end;
    end;
  end;

//Effacement des atomes du motif
  n:=nb_motif;
  for i:=1 to nb_to_del do begin
    for j:=1 to nb_motif do begin
      s:=motif[j].element;
      s2:=uptrim(s);
      if (s2 = elem_to_del[i])then motif[j].nom:='';
    end;
  end;
  n:=0;
  for i:=1 to nb_motif do begin
    if (motif[i].nom <> '')then begin
      n:=n+1;
      new(atdel[n]);
      atdel[n]^:=motif[i];
    end;
  end;
  for i:=1 to n do motif[i]:=atdel[i]^ ;
  for i:=1 to n do dispose(atdel[i]);
  nb_motif:=n;
  set_typ_liaisons;
  initialise(sender);
  ecrit_stringgrid2;
  feffaceE.visible:=false;
end;

procedure TfeffaceE.peint_stringgrid1(Sender: TObject; Col, Row: Integer;
  Rect: TRect; State: TGridDrawState);
//-----------------------------------------------------------------------
var
  s        : string;
  posx     : integer;
begin
  s:=trim(StringGrid1.cells[col,row]);
  if (pos('*',s) > 0) then begin
    stringgrid1.canvas.brush.color:=$EECBFF;
    stringgrid1.canvas.fillrect(rect);
    stringgrid1.canvas.font.color:=clblack;
    stringgrid1.canvas.textout(rect.left+2,rect.top+2,stringgrid1.cells[col,row]);
  end ;
  posx:= ((Rect.right-rect.left-2)-stringgrid1.canvas.textWidth(s)) div 2;
  stringgrid1.canvas.textrect(rect,rect.left+posx,rect.top,s);
 end;

procedure TfeffaceE.onclic(Sender: TObject);
//----------------------------------------
var s:string;
begin
  s:=stringGrid1.cells[acol1,arow1];
  if (pos('*',s) > 0) then delete (s,pos('*',s),1)
  else s:=s+'*';
  stringGrid1.cells[acol1,arow1]:=s;
end;

end.
