unit fichiers;

interface

Uses
 SysUtils, WinTypes, WinProcs, Messages,
 Controls, StdCtrls,  math, oemath;

procedure code(var v:vecteur4; var s:string);
Procedure set_positions;
procedure set_transla;
procedure set_centre;
procedure licarte_output;
procedure licarte_input;
procedure lit_powdercell(var ier:integer);
procedure lit_lazyPulverix(var ier:integer);
procedure lit_poudrix(var ier:integer);
procedure ecrit_fichier_shelx;
procedure ecrit_fichier_ascii;
procedure lit_fichier_ascii;
procedure ecrit_fichier_cif;
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
procedure get_spgr;

implementation

uses
  dessin,mainmenu,digicode,formula,brown;
type
  tab6                        = array[1..6] of real;
var
  tx_lu,ty_lu,tz_lu           : array[1..4] of double;
  npos_lu,nbtrans_lu          : integer;
  tp_lu                       : array[1..192,1..3,1..4]of double;
  npos_depart                 : integer;
  
//Extrait jusqu'a 12 rels d'une chaine s. no:nb de rels trouvs(==>tableau )
procedure dec(s:string; var tableau:tab_reel; var no,ier:integer);
//----------------------------------------------------------------
var
  s1                            : string;
  i,j,l                         : integer;
 no_erreur                      : array[1..12] of integer;

begin
  s:=trim(s);
  l:=length(s);
  no:=0;
  for i:=1 to l do begin
    if (s[i] = ',') then s[i]:=' ';
  end;
  for i:=1 to 11 do tableau[i]:=0;

  while (l > 0) do begin
    j:=pos(' ',s);
    if (j = 0)then j:=l;
    no:=no+1;
    s1:=copy(s,1,j);
    s1:=trim(s1);
    no_erreur[no]:=0;
    val(s1,tableau[no],ier);
    if(ier <> 0)then  no_erreur[no]:=1;
    delete(s,1,j);
    s:=trim(s);
    l:=length(s);
  end;
 end;

procedure decchaine(s: string; var line: vecteur3; var t: double; var ier:integer);{
----------------------------------------------------------------------------------
Dcode une sous chaine d'une chaine-position}
var
  i,j,l,k          : integer;
  s1               : string;
const
 ct   : array[1..22] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6',
          '-1/2',  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6',
          '1/2', '1/3', '2/3', '1/4', '3/4', '1/6', '5/6');
  vt   : array[1..22] of real =
  ( 0.,0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333,
      -0.5, -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333,
       0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333);

const
  code_pos      : array[1..14] of string =
  ('-Y+X','-X+Y','X+Y','X-Y','Y-X','-X','-Y', '-Z','+X','+Y','+Z','X','Y','Z');
  ligne         : array[1..42] of double   =
  (  1,-1,0,
  -1,1,0,
   1,1,0,
  1,-1,0,
  -1,1,0,
  -1,0,0,
  0,-1,0,
  0,0,-1,
  1,0,0,
  0,1,0,
  0,0,1,
  1,0,0,
  0,1,0,
  0,0,1);
begin

//suppression des formats fortran
   s1:=s;
   i:=pos(' .',s1);
   if(i > 0)then s1[i]:='0';
   i:=pos('. ',s1);
   if(i > 0)then s1[i+1]:='0';

//recherche vecteur de position
   ier:=1;
   s1:=trim(s1);
   for i:=1 to 14 do begin
     j:=pos(code_pos[i],s1);
     if (j > 0) then begin
     //if (code_pos[i] =s1) then begin
       k:=(i-1)*3 ;
       line[1]:=ligne[k+1];
       line[2]:=ligne[k+2];
       line[3]:=ligne[k+3];
       l:=length(code_pos[i]);
       delete(s1,j,l);
       if (s1 <> '') and (s1[length(s1)] = '+')then delete(s1,length(s1),1);
       ier:=0;
       break;
     end;
   end;

//Translations
   s1:=trim(s1);
   if (s1 = '')then begin
     t:=0;
     exit;
   end else begin
     for i:=1 to 22 do begin
       if (s1 = ct[i])then begin
         t:=vt[i];
         exit;
       end;
     end;
   end;
   val(s1,t,ier);
end;

procedure decsym(s: string; var r:matrice3; var t:vecteur3; var ier:integer); {
-----------------------------------------------------------------------------}
  {Dcodage d'une position, Sparation des 3 sous-chaines, par recherche des
  virgules}
var
  s1,s2,s3                   : string;
  i                          : integer;
  v                          : vecteur3;
begin

  i:=pos(',',s);
  s1:=copy(s,1,i);
  s1[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  i:=pos(',',s);
  s2:=copy(s,1,i);
  s2[i]:=' ';
  delete(s,1,i);
  s:=trim(s);

  s3:=s;

  s1:=trim(s1);
  s2:=trim(s2);
  s3:=trim(s);

  {Dcodage de chaque sous-chaine}
  for i:=1 to 3 do begin
    v[i]:=0;
    t[i]:=0;
  end;
  decchaine(s1,v,t[1],ier);
  for i:=1 to 3 do r[1,i]:=v[i];
  decchaine(s2,v,t[2],ier);
  for i:=1 to 3 do r[2,i]:=v[i];
  decchaine(s3,v,t[3],ier);
  for i:=1 to 3 do r[3,i]:=v[i];
end;

procedure dec_val(s:string;var r:vecteur3;var t:real);
//---------------------------------------------------
//dcode une chaine contenant une position ==> un vecteur + la translation
var
  i,n,ier  : integer;
  s1       : string;
const
  cxyz : array[1..14] of string[4]=
  ('X-Y','Y-X','-X+Y','-Y+X','X+Y',
  'X','Y','Z',
   '+X','+Y','+Z',
  '-X','-Y','-Z');
  vxyz : array [1..42] of real=
   (1,-1, 0,-1, 1, 0, -1, 1, 0, 1,-1, 0,1,1,0,
    1, 0, 0, 0, 1, 0, 0, 0, 1,
    1, 0, 0, 0, 1, 0, 0, 0, 1,
   -1, 0, 0 ,0,-1, 0, 0, 0,-1);
  ct   : array[1..22] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6',
          '-1/2',  '-1/3','-2/3','-1/4','-3/4','-1/6','-5/6',
          '1/2', '1/3', '2/3', '1/4', '3/4', '1/6', '5/6');
  vt   : array[1..22] of real =
  ( 0.,0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333,
      -0.5, -0.3333333,-0.6666667,-0.25,-0.75,-0.166667,-0.83333,
       0.5, 0.3333333, 0.6666667, 0.25,  0.75, 0.166667, 0.83333);
begin
  t:=0;
  s:=trim(s);

//Recherche de la translation ==> t
  ier:=1;
  for i:=1 to 22 do begin
    if (pos(ct[i],s) > 0)then begin
      t:=vt[i];
      ier:=0;
      break;
    end;
  end;
  if (t <> 0)then begin
    delete(s,pos(ct[i],s),length(ct[i]));
  end;
  if (s[1] = '+')then begin
    delete(s,1,1);
    s:=trim(s);
  end;
//Recherche de la position ==> vecteur r
  for i:=1 to 14 do begin
    s1:=trim(cxyz[i]);
    if (s1 = s)then begin
      n:=(i-1)*3;
      r[1]:=vxyz[n+1];
      r[2]:=vxyz[n+2];
      r[3]:=vxyz[n+3];
      exit;
    end;
  end;
  erreur('Cannot decode '+s);
  halt;
end;

procedure code(var v:vecteur4; var s:string);
//------------------------------------------
//code une v=vecteur[4] en s=chaine contenant une position
var
  i         : integer;
  s1,s2     : string;
const
  cxyz : array[1..9] of string[4]=
  (' X',' Y',' Z','-X','-Y','-Z',' X-Y',' Y-X','X+Y');
  sxyz : array [1..9] of string =
  ( '1 0 0','0 1 0','0 0 1','-1 0 0','0-1 0','0 0-1','1-1 0','-1 1 0','1 1 0');
  ct   : array[1..8] of string[4]=
  ('    ','+1/2','+1/3','+2/3','+1/4','+3/4','+1/6','+5/6');
  vt   : array[1..8] of double =
  ( 0.,0.5,0.3333333,0.6666667,0.25,0.75,0.166667,0.83333);
begin
  s:='';
  s2:='';
  str(v[1]:2:0,s1);
  s2:=s2+s1;
  str(v[2]:2:0,s1);
  s2:=s2+s1;
  str(v[3]:2:0,s1);
  s2:=s2+s1;
  s2:=trim(s2);
  while (pos('-0',s2) > 0) do begin
    i:=pos('-0',s2);
    s2[i]:=' ';
  end;
  s2:=trim(s2);
  for i:=1 to 9 do begin
    if (sxyz[i] = s2)then begin
      s:=cxyz[i];
    end;
  end;

  //Translation
  if(v[4] = 0)then exit;
  if (v[4] < 0)then v[4]:=1+v[4];
  if (v[4] > 1) then v[4]:=v[4]-1;
  for i:=1 to 8 do begin
    if (abs(v[4]-vt[i]) < 0.001)then begin
      s1:=ct[i];
      s:=s+s1;
      exit;
    end;
  end;
end;

procedure set_centre;
//------------------
var
  i,j,k            :  integer;
begin
    for i:=1 to npos do begin
      for j:=1 to 3 do begin
        for k:=1 to 3 do tp[npos+i,j,k]:=-tp[i,j,k];
        tp[npos+i,j,4]:=tp[i,j,4];
      end;
    end;
    npos:=2*npos;
end;

//Etablit les translations de rseau;
procedure set_transla;{
----------------------}
var
  i,j,k,it,nn,ii                : integer;
begin
  nbtrans:=0;
  if (systeme = 'HEXA') and (bravais = 'R') then begin
    nbtrans:=2;
    tx[1]:=0.3333333333;
    ty[1]:=0.6666666666;
    tz[1]:=0.6666666666;
    tx[2]:=0.6666666666;
    ty[2]:=0.3333333333;
    tz[2]:=0.3333333333;
  end;
  if (bravais = 'F') then begin
    nbtrans:=3;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
    tx[2]:=0.5;
    ty[2]:=0;
    tz[2]:=0.5;
    tx[3]:=0.5;
    ty[3]:=0.5;
    tz[3]:=0;
  end;
  if (bravais = 'I') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5 ;
    tz[1]:=0.5;
  end;
  if (bravais = 'A') then begin
    nbtrans:=1;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
  end;
  if (bravais = 'B') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0;
    tz[1]:=0.5;
  end;
  if (bravais = 'C') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5;
    tz[1]:=0;
  end;

// Si le nb de translations est >0 on implmente le set d'oprateurs de
// symtrie.
  if(nbtrans > 0) then begin
    nn:=npos;
    for it:=1 to nbtrans do begin
      for i:=1 to npos do begin
        nn:=nn+1;
        for j:=1 to 3 do begin
          for k:=1 to 4 do tp[nn,j,k]:=tp[i,j,k];
        end;
        tp[nn,1,4]:=tp[nn,1,4]+tx[it];
        tp[nn,2,4]:=tp[nn,2,4]+ty[it];
        tp[nn,3,4]:=tp[nn,3,4]+tz[it];
        for ii:=1 to 3 do if(tp[nn,ii,4] > 1) then tp[nn,ii,4]:=tp[nn,ii,4]-1;
      end;
    end;
    npos:=nn;
  end; 

end;

procedure set_centre_lu;
//----------------------
var
  i,j,k            :  integer;
begin
    for i:=1 to npos_lu do begin
      for j:=1 to 3 do begin
        for k:=1 to 3 do tp_lu[npos_lu+i,j,k]:=-tp_lu[i,j,k];
        tp_lu[npos_lu+i,j,4]:=tp_lu[i,j,4];
      end;
    end;
    npos_lu:=2*npos_lu;
end;

Procedure set_positions;{
------------------------}
var
  i,j,n                            : integer;
  s,s1                             : string;
  t                                : real;
  r                                : vecteur3;
  nom                              : textfile;

begin
  s:=trim(systeme)+'.pos';
  chdir(repertoire_origine);
  AssignFile(nom,s);
  reset(nom);
  while not(eof(nom)) do begin
    readln(nom,s);
    s:=trimRight(s);
    if (s = groupe_espace)then begin
      readln(nom,centre);
      readln(nom,npos);
      for i:=1 to npos do begin
        readln(nom,s);
        s_pos[i]:=s;
        s:=ansiuppercase(s);
        s_pos[i]:=s;
        //X
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dec_val(s1,r,t);
        for j:=1 to 3 do tp[i,1,j]:=r[j];
        tp[i,1,4]:=t;
        //Y
        j:=pos(',',s);
        s1:=copy(s,1,j-1);
        delete(s,1,j);
        dec_val(s1,r,t);
        for j:=1 to 3 do tp[i,2,j]:=r[j];
        tp[i,2,4]:=t;
        //Z
        dec_val(s,r,t);
        for j:=1 to 3 do tp[i,3,j]:=r[j];
        tp[i,3,4]:=t;
      end;
      readln(nom,n);
      if(n > 0)then for i:=1 to n do readln(nom,s);
      break;
    end;
  end;
  set_transla;
  if (centre > 0)then set_centre;
  npos_gene:=npos;
  closeFile(nom);
end;

//------------------------------------------------------------------------------

procedure set_transla_lu(var s:string);
//-------------------------------------
var
  s1     : string[1];

begin
  s1:=copy(s,1,1);
  if (s1 = 'P')then nbtrans_lu:=0;
  if (systeme = 'HEXA') and (s1 = 'R') then begin
    nbtrans_lu:=2;
    tx_lu[1]:=0.3333333333;
    ty_lu[1]:=0.6666666666;
    tz_lu[1]:=0.6666666666;
    tx_lu[2]:=0.6666666666;
    ty_lu[2]:=0.3333333333;
    tz_lu[2]:=0.3333333333;
  end;
  if (s1 = 'F') then begin
    nbtrans_lu:=3;
    tx_lu[1]:=0;
    ty_lu[1]:=0.5;
    tz_lu[1]:=0.5;
    tx_lu[2]:=0.5;
    ty_lu[2]:=0;
    tz_lu[2]:=0.5;
    tx_lu[3]:=0.5;
    ty_lu[3]:=0.5;
    tz_lu[3]:=0;
  end;
  if (s1 = 'I') then begin
    nbtrans_lu:=1;
    tx_lu[1]:=0.5;
    ty_lu[1]:=0.5 ;
    tz_lu[1]:=0.5;
  end;
  if (s1 = 'A') then begin
    nbtrans_lu:=1;
    tx_lu[1]:=0;
    ty_lu[1]:=0.5;
    tz_lu[1]:=0.5;
  end;
  if (s1 = 'B') then begin
    nbtrans_lu:=1;
    tx_lu[1]:=0.5;
    ty_lu[1]:=0;
    tz_lu[1]:=0.5;
  end;
  if (s1 = 'C') then begin
    nbtrans_lu:=1;
    tx_lu[1]:=0.5;
    ty_lu[1]:=0.5;
    tz_lu[1]:=0;
  end;

end;

procedure hermann_mauguin;
//------------------------
var
  v4                                            : vecteur4;
  r                                             : matrice3;
  t                                             : vecteur3;
  icentre,n,nb_regles,m                         : integer;
  s,ss,nom_groupe     : string;
  s1                  : string[1];
  i,j,k,ier,ii        : integer;
  nn,it               : integer;
  dif1,dif2,dif3      : double;
  nomf,noms           : textfile;
  s_pos2                                   : array[1..192] of string[24];

begin
     //assignfile(noms,'espion');
     //rewrite(noms);
     chdir(repertoire_origine);
     s:=systeme+'.pos';
     assignfile(nomf,s);
     reset(nomf);

     while not(eof(nomf)) do begin
       readln(nomf,s);
       s:=trim(s);
       nbtrans_lu:=1;
       npos_lu:=0;
       if (s <> '')then begin
         nom_groupe:=uppercase(trim(s));
         set_transla_lu(nom_groupe);
         readln(nomf,icentre);
         readln(nomf,n);
         m:=(nbtrans_lu+1)*n*(icentre+1);

//On passe si le nombre de positions ou le centre ne coincident pas
         if (m <> npos) or (icentre <> centre) then begin
           for i:=1 to n do readln(nomf);
           readln(nomf,n);
           if (n > 0)then for i:=1 to n do readln(nomf);
           continue;
         end;

//On lit et on dcode les positions
         for i:=1 to n do begin
           readln(nomf,s);
           decsym(s,r,t,ier);
           if (ier = 1)then begin
             erreur('Non decoded position: '+s);
             exit;
           end;
           npos_lu:=npos_lu+1;
           for k:=1 to 3 do begin
             for j:= 1 to 3 do tp_lu[npos_lu,k,j]:=r[k,j];
             tp_lu[npos_lu,k,4]:=t[k];
           end;
         end;

//Ajout du centre
         if (icentre = 1)then set_centre_lu;

//Translations de Bravais
         if(nbtrans_lu > 0) then begin
           nn:=npos_lu;
           for it:=1 to nbtrans_lu do begin
             for i:=1 to npos_lu do begin
               nn:=nn+1;
               for j:=1 to 3 do begin
                 for k:=1 to 4 do tp_lu[nn,j,k]:=tp_lu[i,j,k];
               end;
               tp_lu[nn,1,4]:=tp_lu[nn,1,4]+tx_lu[it];
               tp_lu[nn,2,4]:=tp_lu[nn,2,4]+ty_lu[it];
               tp_lu[nn,3,4]:=tp_lu[nn,3,4]+tz_lu[it];
               for ii:=1 to 3 do if(tp_lu[nn,ii,4] > 1) then
               tp_lu[nn,ii,4]:=tp_lu[nn,ii,4]-1;
             end;
           end;
           npos_lu:=nn;
         end;

//Ecriture des positions
    (* for i:=1 to npos_lu do begin
       ss:='';
       s:='';
       for j:=1 to 3 do begin
         for k:=1 to 4 do v4[k]:=tp_lu[i,j,k];
         code(v4,s);
         s:=lowercase(s);
         ss:=ss+s+',';
       end;
       s_pos2[i]:=ss;
       writeln(noms,s_pos[i],'   ',ss);
     end; *)


//On compare
         k:=0;
         for i:=1 to npos_lu do begin
           ier:=1;
           for ii:=1 to npos do begin
                dif1:=abs(tp_lu[i,1,1]-tp[ii,1,1])+abs(tp_lu[i,1,2]-tp[ii,1,2])+
                      abs(tp_lu[i,1,3]-tp[ii,1,3])+abs(tp_lu[i,1,4]-tp[ii,1,4]);
                dif2:=abs(tp_lu[i,2,1]-tp[ii,2,1])+abs(tp_lu[i,2,2]-tp[ii,2,2])+
                      abs(tp_lu[i,2,3]-tp[ii,2,3])+abs(tp_lu[i,2,4]-tp[ii,2,4]);
                dif3:=abs(tp_lu[i,3,1]-tp[ii,3,1])+abs(tp_lu[i,3,2]-tp[ii,3,2])+
                      abs(tp_lu[i,3,3]-tp[ii,3,3])+abs(tp_lu[i,3,4]-tp[ii,3,4]);
                if (dif1+dif2+dif3 < 0.01)then begin
                  ier:=0;
                  k:=k+1;
                  break;
                end;
           end;

           (*if (ier = 1)then begin
             writeln(noms,'erreur:',i:5,'  ',s_pos2[i]);
             for j:=1 to 3 do write(noms,tp_lu[i,j,1]:4:0,tp_lu[i,j,2]:4:0,
             tp_lu[i,j,2]:4:0,tp_lu[i,j,4]:8:4);
             writeln(noms);
           end;*)

         end;
         //closefile(noms);

//On continue ou on arrte
         if (ier = 1)then begin
           readln(nomf,n);
           if (n > 0)then for i:=1 to n do readln(nomf);
           continue;
         end else begin;
           fmainmenu.label7.caption:='Possible Space Group : '+nom_groupe ;
           closefile(nomf);
           exit;
         end;

       end;
     end;
     erreur('GRETEP Cannot identify the Space Group in the Shelx file');
     fmainmenu.label7.caption:='Space Group not identified: ';
end;

procedure get_spgr;
//-----------------
var
  s,nom_groupe,ch1,ch2: string;
  s1                  : string[1];
  i,j,k,ier,ii        : integer;
  nn,it,numero_groupe : integer;
  dif1,dif2,dif3      : double;
  nomf,noms           : textfile;
  label 1;
begin
     nom_groupe:='';
     chdir(repertoire_origine);

//Recherche d'un groupe de Hall
     assignfile(nomf,'spgr.peq');
     reset(nomf);
     repeat
         readln(nomf,s);
         s:=trim(s);
     until (s = systeme);
     while not(eof(nomf)) do begin
       readln(nomf,s1,s);
       if (s1 <> ' ')then break; //autre systme

//Dbut d'un groupe
       nom_groupe:=trim(s);

//!!!!!!!!!!!!!!!!!!!!
        //pour debugger
       //if (trim(copy(nom_groupe,1,8)) <> 'P21/NB') then continue;
//!!!!!!!!!!!!!!!!!!!!!

       readln(nomf,npos_lu);
       for i:=1 to npos_lu do begin
         for j:=1 to 3 do read(nomf,tp_lu[i,j,1],tp_lu[i,j,2],
                                      tp_lu[i,j,3],tp_lu[i,j,4]);
         readln(nomf);
       end;

//Getspec ne gnre pas les translations de Bravais
       set_transla_lu(nom_groupe);
       if(nbtrans > 0) then begin
         nn:=npos_lu;
         for it:=1 to nbtrans_lu do begin
           for i:=1 to npos_lu do begin
             nn:=nn+1;
             for j:=1 to 3 do begin
               for k:=1 to 4 do tp_lu[nn,j,k]:=tp_lu[i,j,k];
             end;
             tp_lu[nn,1,4]:=tp_lu[nn,1,4]+tx_lu[it];
             tp_lu[nn,2,4]:=tp_lu[nn,2,4]+ty_lu[it];
             tp_lu[nn,3,4]:=tp_lu[nn,3,4]+tz_lu[it];
             for ii:=1 to 3 do begin
               if(tp_lu[nn,ii,4] > 1) then tp_lu[nn,ii,4]:=tp_lu[nn,ii,4]-1;
               if(tp_lu[nn,ii,4] < 0) then tp_lu[nn,ii,4]:=tp_lu[nn,ii,4]+1;
             end;
           end;
         end;
         npos_lu:=nn;
       end;

//Comparaison avec les positions lues dans Shelx
       ier:=1;
       if (npos_lu <> npos)then continue;

//Translation positive
       for i:=1 to npos_lu do begin
           if (tp_lu[i,1,4] >= 1)then tp_lu[i,1,4]:=tp_lu[i,1,4]-1;
           if (tp_lu[i,2,4] >= 1)then tp_lu[i,2,4]:=tp_lu[i,2,4]-1;
           if (tp_lu[i,3,4] >= 1)then tp_lu[i,3,4]:=tp_lu[i,3,4]-1;
           if (tp_lu[i,1,4] < 0)then tp_lu[i,1,4]:=tp_lu[i,1,4]+1;
           if (tp_lu[i,2,4] < 0)then tp_lu[i,2,4]:=tp_lu[i,2,4]+1;
           if (tp_lu[i,3,4] < 0)then tp_lu[i,3,4]:=tp_lu[i,3,4]+1;
       end;

       for i:=1 to npos_lu do begin
         ier:=1;
         for ii:=1 to npos do begin
           dif1:=abs(tp_lu[i,1,1]-tp[ii,1,1])+abs(tp_lu[i,1,2]-tp[ii,1,2])+
                 abs(tp_lu[i,1,3]-tp[ii,1,3])+abs(tp_lu[i,1,4]-tp[ii,1,4]);
           dif2:=abs(tp_lu[i,2,1]-tp[ii,2,1])+abs(tp_lu[i,2,2]-tp[ii,2,2])+
                 abs(tp_lu[i,2,3]-tp[ii,2,3])+abs(tp_lu[i,2,4]-tp[ii,2,4]);
           dif3:=abs(tp_lu[i,3,1]-tp[ii,3,1])+abs(tp_lu[i,3,2]-tp[ii,3,2])+
                 abs(tp_lu[i,3,3]-tp[ii,3,3])+abs(tp_lu[i,3,4]-tp[ii,3,4]);
           if (dif1+dif2+dif3 < 0.01)then begin
             ier:=0;
             break;
           end;
         end;
         if (ier = 1)then break;
       end;
       if (ier = 0)then begin
         ch1:=trim(copy(nom_groupe,1,20));
         groupe_espace:=trim(ch1);
         Ch2:=trim(copy(nom_groupe,24,16));
         s:=ch1+' / '+ch2+' (Nb '+trim(copy(nom_groupe,41,6))+')';
         fmainmenu.label7.caption:='Possible Space Group : '+s ;
//       fmainmenu.beep;
         exit;
       end;

     end;

     closefile(nomf);
//   beep;
1:     Hermann_Mauguin;
end;
//------------------------------------------------------------------------------


{Lecture des cartes du fichier de sortie de Shelx76 ou 93}
procedure licarte_output;{
-------------------------}
var
  nomf                                          : TextFile;
  s4                                            : string[4];
  c1                                            : string[1];
  s2                                            : string[2];
  s,s1                                          : string;
  //depi2                                         : double;
  valeur                                        : tab_reel;
  nb_valeurs,ier,i,j,no                         : integer;
  som                                           : real;
  v4                                            : vecteur4;
  r                                             : matrice3;
  t                                             : vecteur3;

begin

//Shelx 90 ou 76?
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  type_fichier_shelx:=0;
  while not(eof(nomf)) do begin
    readln(nomf,s);
    if (pos('ATOM',s) > 0) and (pos('x         y         z',s) > 0)then begin
        type_fichier_shelx:=93;
        break;
    end;
    if (pos('ATOM',s) > 0) and (pos('X/A',s) > 0)then begin
        type_fichier_shelx:=76;
        break;
    end;
  end;
  closefile(nomf);
  if (type_fichier_shelx = 0)then begin
    erreur('The file '+extractFileName(nom_fichier_shelx)+
    ' Seems not to be a Shelx file');
    exit;
  end;
  npos:=1;
  for i:=1 to 3 do begin
    for j:=1 to 4 do begin
      tp[1,i,j]:=0;
      if(i = j)then tp[1,i,j]:=1;
    end;
  end;

//On rajoute la position triviale
  npos:=1;
  s_pos[1]:=' X, Y, Z';
  selected[1]:=0;
  for i:=1 to 3 do
  for j:=1 to 4 do begin
      tp[1,i,j]:=0;
      if (i = j)then tp[1,i,j]:=1;
  end;

//Dcodage du mode de rseau
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  ibrav:=0;
  centre:=1;
  readln(nomf,s4,titre);
  if (s4 <> 'TITL')then Titre:='';
  while not eof(nomf) do begin
    readln(nomf,c1,s4,s);
    if (s4 = 'LATT')then begin
      s:=trim(s);
      val(s,ibrav,ier);
      if(ibrav > 0)then centre:=1;
      if(ibrav < 0)then begin
        centre:=-1;
        ibrav:=-ibrav
      end;
      break;
    end;
  end;
  if (ibrav = 0)then ibrav:=1;
  closeFile(nomf);

  case ibrav of
    1: bravais:='P';
    2: bravais:='I';
    3: bravais:='R';
    4: bravais:='F';
    5: bravais:='A';
    6: bravais:='B';
    7: bravais:='C';
  end;

//Dtection de la maille
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,c1,s4,s);
    if(s4 = 'CELL') then  begin
      dec(s,valeur,no,ier);
      lambda:=valeur[1];
      for i:=1 to 6 do cel[i]:=valeur[i+1];
      setmat;
      quel_systeme;
      break;
    end;
  end;
  closefile(nomf);

//Lecture des symties
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,c1,s4,s);
    if(s4 = 'SYMM')then begin
      s:=trim(s);s:=uppercase(s);
      while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
      if (s = 'X,Y,Z') then continue;
      decsym(s,r,t,ier);
      if (ier = 1)then begin
        erreur('Non decoded position: '+s);
        exit;
      end;
      npos:=npos+1;
      selected[npos]:=0;
      for i:=1 to 3 do begin
        for j:= 1 to 3 do tp[npos,i,j]:=r[i,j];
        tp[npos,i,4]:=t[i];
      end;
      s:='';
      for j:=1 to 3 do begin
        for i:=1 to 4 do v4[i]:=tp[npos,j,i];
        code(v4,s1);
        s:=s+s1+',';
      end;
      s_pos[npos]:=copy(s,1,length(s)-1);
    end;
  end;
  set_transla;
  if (centre = 1)then set_centre;
  npos_gene:=npos;
  closefile(nomf);

//Lecture des coordonnes
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  nb_motif:=0;
  ier:=1;
  while not eof(nomf) do begin
    s:='';
    readln(nomf,s);
    if(type_fichier_shelx = 93)then s1:='ATOM           x         y         z';
    if(type_fichier_shelx = 76)then s1:='ATOM      X/A';
    if (pos(s1,s) > 0 ) then begin
      ier:=0;
      break;
    end;
  end;

  if (ier = 1)then begin
    erreur
    ('No detected atoms in the file '+extractFileName(nom_fichier_shelx));
    closefile(nomf);
    exit;
  end;

  readln(nomf);
  while not eof(nomf) do begin
    readln(nomf,c1,s4,s);
    s1:='';
    s1:=s1+c1;
    s1:=trim(s1);
    s4:=trim(s4);
    if(s4 = '') and (s1 = '')then break;                     //atome,x,y,etrc..
    readln(nomf);                                            //sigmas
    if(type_fichier_shelx = 93) then readln(nomf);           //ligne blanche
    for i:=1 to 10 do valeur[i]:=0;
    dec(s,valeur,nb_valeurs,ier);
    if(ier = 0) then begin
      nb_motif:=nb_motif+1;
      with motif[nb_motif] do begin
        s4:=trim(s4);
        s:=copy(s4,1,4);
        traite_nom_element(s);
        s2:=trim(copy(s,1,2));
        element:=s2;
        labell:=copy(s,3,2);
        nom:=uppercase(s);
        x:=valeur[1];
        y:=valeur[2];
        z:=valeur[3];
        beta[1]:=valeur[5];
        beta[2]:=valeur[6];
        beta[3]:=valeur[7];
        beta[4]:=valeur[10];
        beta[5]:=valeur[9];
        beta[6]:=valeur[8];
        som:=0;
        for j:=2 to 6 do som:=som+beta[j];
        if (som = 0)then iso:=1 else iso:=0;
      end;
    end else begin
      erreur('error '+s+' '+s4);
      exit;
    end;
  end;
  closeFile(nomf);

// On slectionne la position triviale  (tableau tp_sel)
  npos_sel:=1;
  selected[1]:=1;
  for i:=1 to 3 do
  for j:=1 to 4 do tp_sel[1,i,j]:=tp[1,i,j];

//Types de liaisons
  set_typ_liaisons;

end;

//17 juin 2003 : Verification des cartes SYMM: Recherche des lments de symtrie
//qui peuvent tre dduits du set de base par translation; (programme cif2sx de
//L. Ferrugia
{exemple:
LATT   -3
SYMM     - Y, + X - Y, + Z
SYMM     - Y, - X, 1/2 + Z
SYMM     - X + Y, - X, + Z
SYMM     + X, + X - Y, 1/2 + Z
SYMM     - X + Y, + Y, 1/2 + Z
SYMM     2/3 - Y, 1/3 + X - Y, 1/3 + Z
SYMM     2/3 - Y, 1/3 - X, 5/6 + Z
SYMM     2/3 - X + Y, 1/3 - X, 1/3 + Z
SYMM     2/3 + X, 1/3 + X - Y, 5/6 + Z
SYMM     2/3 - X + Y, 1/3 + Y, 5/6 + Z
}
procedure verif_ferrugia;
//-----------------------
var
  i,j,k,n,nn,it,ii,
  i1,i2              : integer;
  s                  : string;
  tpp                : array[1..192,1..3,1..4]of double;
  v4                 : vecteur4;
  indic              : array[1..192] of integer;
  dif,dif1,dif2,dif3 : double;
  nomf:textfile;

begin
  if (nbtrans = 0)then exit;
 (* assignfile(nomf,'espion_fer.txt');
  rewrite(nomf);*)

//Codage des positions
 // writeln(nomf,'depart');
  for i:=1 to npos do begin
       s_pos[i]:='';
       for j:=1 to 3 do begin
         for k:=1 to 4  do v4[k]:=tp[i,j,k];
         code(v4,s);
         if (j = 3) then s_pos[i]:=s_pos[i]+s else s_pos[i]:=s_pos[i]+s+',';
       end;
    //   writeln(nomf,i:4,' ',s_pos[i]);
  end;

  for i:=1 to npos do indic[i]:=1;
  for i1:=1 to npos-1 do begin
    for i2:=i1+1 to npos do begin
      dif:=0;
      for j:=1 to 3 do begin
        for k:=1 to 3 do begin
          dif:=dif+abs(tp[i2,j,k]-tp[i1,j,k]);
        end;
      end;
  (*    if (i1 = 2) and (i2 = 7)then begin
        erreur('?');
      end; *)
      if (dif = 0)then begin
        dif1:=tp[12,1,4]-tp[i1,1,4];
        dif2:=tp[12,2,4]-tp[i1,2,4];
        dif3:=tp[12,3,4]-tp[i1,3,4];
       // writeln(nomf,'i1=',i1:2,' i2=',i2:2);
        //writeln(nomf,tp[12,1,4]:8:6,tp[12,2,4]:8:6,tp[12,3,4]:8:6) ;
        //writeln(nomf,tp[11,1,4]:8:6,tp[11,2,4]:8:6,tp[11,3,4]:8:6);
        //writeln(nomf,dif1:8:2,dif2:8:2,dif3:8:2);
        if (dif1 < 0.001) and (dif2 < 0.001) and (dif3 < 0.001)then begin
          indic[i2]:=0;
          break;
        end;
        dif:=0;
        for i:=1 to nbtrans do begin
          dif:=dif+abs(dif1-tx[i])+abs(dif2-ty[i])+abs(dif3-tz[i]);
          if (dif < 0.0001)then begin
            indic[i2]:=0;
            break;
          end;
        end;
      end;
    end;
  end;
  n:=0;
  for i:=1 to npos_depart do begin
    if (indic[i] = 0)then continue;
    n:=n+1;
    for j:=1 to 3 do
    for k:=1 to 4 do tpp[n,j,k]:=tp[i,j,k];
  end;
  npos:=n;
  for i:=1 to npos do begin
    for j:=1 to 3 do
    for k:=1 to 4 do tp[n,j,k]:=tpp[i,j,k];
  end;

//Codage des positions
  //writeln(nomf,'suppression des translations');
  for i:=1 to npos do begin
       s_pos[i]:='';
       for j:=1 to 3 do begin
         for k:=1 to 4  do v4[k]:=tp[i,j,k];
         code(v4,s);
         if (j = 3) then s_pos[i]:=s_pos[i]+s else s_pos[i]:=s_pos[i]+s+',';
       end;
      // writeln(nomf,i:4,' ',s_pos[i]);
  end;
  //writeln(nomf);

//Suppression des translations > 1 ou ngatives
  for i:=1 to npos do begin
    if (tp[i,1,4] >= 1)then tp[i,1,4]:=tp[i,1,4]-1;
    if (tp[i,2,4] >= 1)then tp[i,2,4]:=tp[i,2,4]-1;
    if (tp[i,3,4] >= 1)then tp[i,3,4]:=tp[i,3,4]-1;
    if (tp[i,1,4] < 0)then tp[i,1,4]:=tp[i,1,4]+1;
    if (tp[i,2,4] < 0)then tp[i,2,4]:=tp[i,2,4]+1;
    if (tp[i,3,4] < 0)then tp[i,3,4]:=tp[i,3,4]+1;
  end;

//On regenre le set  partir des translations
  if(nbtrans > 0) then begin
      nn:=npos;
      for it:=1 to nbtrans do begin
        for i:=1 to npos do begin
          nn:=nn+1;
          for j:=1 to 3 do begin
            for k:=1 to 4 do tp[nn,j,k]:=tp[i,j,k];
          end;
          tp[nn,1,4]:=tp[nn,1,4]+tx[it];
          tp[nn,2,4]:=tp[nn,2,4]+ty[it];
          tp[nn,3,4]:=tp[nn,3,4]+tz[it];
          for ii:=1 to 3 do if(tp[nn,ii,4] > 1) then tp[nn,ii,4]:=tp[nn,ii,4]-1;
        end;
      end;
      npos:=nn;
  end;

//On regenre le set  partir des translations
  if (centre > 0) then begin
      for i:=1 to npos do begin
        for j:=1 to 3 do begin
          for k:=1 to 3 do tp[npos+i,j,k]:=-tp[i,j,k];
          tp[npos+i,j,4]:=tp[i,j,4];
        end;
      end;
      npos:=2*npos;
  end;

//Codage des positions
  for i:=1 to npos do begin
       s_pos[i]:='';
       for j:=1 to 3 do begin
         for k:=1 to 4  do v4[k]:=tp[i,j,k];
         code(v4,s);
         if (j = 3) then s_pos[i]:=s_pos[i]+s else s_pos[i]:=s_pos[i]+s+',';
       end;
  end;

//Suppression des blancs
     for i:=1 to npos do begin
       s:=s_pos[i];
       while(pos(' ',s) > 0) do delete(s,pos(' ',s),1);
       s_pos[i]:=s;
       //writeln(nomf,s_pos[i]);
     end;
    // closefile(nomf);


end;

{Lecture des cartes du fichier d'entre}
procedure licarte_input;{
------------------------}
var
  nomf                                          : TextFile;
  s4                                            : string[4];
  s,s1                                          : string;
  //depi2                                       : double;
  valeur                                        : tab_reel;
  nb_valeurs,ier,i,j,no,nb_atomes               : integer;
  v4                                            : vecteur4;
  r                                             : matrice3;
  t                                             : vecteur3;

  fv                                            : array[1..50] of double;
  nb_fv,m ,aniso,ipart                          : integer;
  p                                             : double;

  elem_sfac                                     : array[1..20] of string[2];
  nb_sfac,numero_sfac,nb_lignes                 : integer;
  const
   dico: array[1..25]  of string[4] =
   ('TITL','CELL','LATT','SYMM','SFAC','UNIT','AXIS','ABSC','FACE','HKLF',
    'MERG','OMIT','EEES','TANG','PHIX','L.S.','AFLS','BOND','LIST','FMAP',
    'GRID','PLAN','WGHT','ILSF','ZERR');
  label 1;
begin
  {$I-}
  nb_atomes:=0;
  type_fichier_shelx:=0;

//Dtection de la maille
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    if(s4 = 'CELL') then  begin
      dec(s,valeur,no,ier);
      lambda:=valeur[1];
      for i:=1 to 6 do cel[i]:=valeur[i+1];
      setmat;
      quel_systeme;
      break;
    end;
  end;
  closefile(nomf);

//Position triviale
  npos:=1;
  s_pos[1]:=' X, Y, Z';
  selected[1]:=0;
  for i:=1 to 3 do begin
    for j:=1 to 4 do begin
      tp[1,i,j]:=0;
      if(i = j)then tp[1,i,j]:=1;
    end;
  end;

//Dcodage du mode de rseau
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  readln(nomf,s4,titre);
  if (s4 <> 'TITL')then Titre:='';
  ibrav:=0;
  centre:=1;
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    s4:=uppercase(s4);
    if (s4 = 'LATT')then begin
      s:=trim(s);
      val(s,ibrav,ier);
      if(ibrav > 0)then centre:=1;
      if(ibrav < 0)then begin
        centre:=-1;
        ibrav:=-ibrav
      end;
      break;
    end;
  end;
  if (ibrav = 0)then ibrav:=1;
  closeFile(nomf);

  case ibrav of
    1: bravais:='P';
    2: bravais:='I';
    3: bravais:='R';
    4: bravais:='F';
    5: bravais:='A';
    6: bravais:='B';
    7: bravais:='C';
  end;

//Lecture des symties
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  while not eof(nomf) do begin
    readln(nomf,s4,s);s4:=uppercase(s4);s:=uppercase(s);
    s4:=uppercase(s4);
    if(s4 = 'SYMM')then begin
      s:=trim(s);s:=uppercase(s);
      while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
      if (s = 'X,Y,Z') then continue;
      while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
      decsym(s,r,t,ier);
      if (ier = 1)then begin
        erreur('Non decoded position: '+s);
        exit;
      end;
      npos:=npos+1;
      selected[npos]:=0;
      for i:=1 to 3 do begin
        for j:= 1 to 3 do tp[npos,i,j]:=r[i,j];
        tp[npos,i,4]:=t[i];
      end;
      s:='';
      for j:=1 to 3 do begin
        for i:=1 to 4 do v4[i]:=tp[npos,j,i];
        code(v4,s1);
        s:=s+s1+',';
      end;
      s_pos[npos]:=copy(s,1,length(s)-1);
    end;
    if(s4 = '')then break;
  end;
  npos_depart:=npos;

//Modif 17 juin 2003 gnration des translations. Ne sont pas appliques;
  if (centre = 1)then set_centre;
  //set_transla;
  nbtrans:=0;
  if (systeme = 'HEXA') and (bravais = 'R') then begin
    nbtrans:=2;
    tx[1]:=0.3333333333;
    ty[1]:=0.6666666666;
    tz[1]:=0.6666666666;
    tx[2]:=0.6666666666;
    ty[2]:=0.3333333333;
    tz[2]:=0.3333333333;
  end;
  if (bravais = 'F') then begin
    nbtrans:=3;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
    tx[2]:=0.5;
    ty[2]:=0;
    tz[2]:=0.5;
    tx[3]:=0.5;
    ty[3]:=0.5;
    tz[3]:=0;
  end;
  if (bravais = 'I') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5 ;
    tz[1]:=0.5;
  end;
  if (bravais = 'A') then begin
    nbtrans:=1;
    tx[1]:=0;
    ty[1]:=0.5;
    tz[1]:=0.5;
  end;
  if (bravais = 'B') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0;
    tz[1]:=0.5;
  end;
  if (bravais = 'C') then begin
    nbtrans:=1;
    tx[1]:=0.5;
    ty[1]:=0.5;
    tz[1]:=0;
  end;
  verif_ferrugia;
  npos_gene:=npos;
  closefile(nomf);

//Lecture des lments  partir des cartes sfac
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  nb_sfac:=0;
  while not eof(nomf) do begin
    readln(nomf,s4,s);
    s4:=trim(uppercase(s4));
    if (s4 = 'SFAC')then begin
      s:=trim(s);
      if (pos('.',s) > 0)then begin
        nb_sfac:=nb_sfac+1;
        elem_sfac[nb_sfac]:=trim(copy(s,1,2));
        continue;
      end;
      while (length(s) > 0) do begin
        s:=trim(s);
        j:=pos(' ',s);
        if(j > 0)then s1:=copy(s,1,j)else s1:=s;
        s1:=trim(s1);
        nb_sfac:=nb_sfac+1;
        elem_sfac[nb_sfac]:=s1;
        if(j > 0)then delete(s,1,j) else break;
        s:=trim(s);
      end;
      //break;
    end;
  end;
  closefile(nomf);

//Lecture des coordonnes -----------------------------------------------------
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  nb_motif:=0;
  ier:=1;

//Recherche de la carte FVAR
  nb_lignes:=0;
  while not eof(nomf) do begin
//-------
    readln(nomf,s4,s);
    s:=trim(s);
    nb_lignes:=nb_lignes+1;
    if (ioresult <> 0)then begin
       erreur('Read error(1) at line Nb '+inttostr(nb_lignes));
       exit;
    end;
//-------
    s4:=uppercase(s4);
    if (s4 = 'FVAR')then begin
      if (s = '')then s:='1';
      break;
    end;
  end;

//Decodage des paramtres de FVAR
  nb_fv:=0;
  for i:=1 to 50 do fv[i]:=0;
  if (s <> '')then begin
    while not eof(nomf) do begin
      for i:=1 to 11 do valeur[i]:=0;
//-------
      if (s <> '')then begin
        dec(s,valeur,nb_valeurs,ier);
        if (ier <> 0)then begin
          erreur('Read error(2) at line Nb '+inttostr(nb_lignes));
          exit;
        end;

        for i:=1 to nb_valeurs do begin
          nb_fv:=nb_fv+1;
          fv[nb_fv]:=valeur[i];
        end;
       end else nb_fv:=0;
//-------
      readln(nomf,s4,s);
      nb_lignes:=nb_lignes+1;
      if (ioresult <> 0)then begin
        erreur('Read error(3) at line Nb '+inttostr(nb_lignes));
        exit;
      end;
//-------
      s4:=uppercase(s4);
      if (s4 <> 'FVAR')then break;
    end;
  end;
  if (s4 = '')then readln(nomf,s4,s);
  if (s4 = 'TREF')then begin
    readln(nomf,s4,s);
    if (s = '') then begin
      closefile(nomf);
      goto 1;
    end;
  end;
  nb_atomes:=1;

//Modification du 12 juin 2003: Si la carte FVAR est absente, on relit jusqu'
//ce que l'on ne trouve plus de carte de commande (dico[]
  if (nb_fv = 0) then begin
    closefile(nomf);
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    ier:=1;
    while not eof(nomf) do begin
      readln(nomf,s4,s);
      if (s4 = '')then continue;
      ier:=0;
      for i:=1 to 25 do begin
        if (uppercase(s4) = dico[i]) then begin
          ier:=1;
          break;
        end;
      end;
      if (ier = 0)then break;
    end;
  end;
//-----------------------------Lecture des cartes atome ------------------------
  ipart:=0;
  while not eof(nomf) do begin
    if (nb_atomes > 1)then begin

       readln(nomf,s4,s);
       nb_lignes:=nb_lignes+1;
       if (ioresult <> 0)then begin
          erreur('Read error(4) at line Nb '+inttostr(nb_lignes));
          exit;
       end;

    end;
    s4:=uppercase(s4);
    s4:=trim(s4);
    if (s4 = 'BLOC') or (s4 = 'AFIX') {or (s4 = 'PART')} or (s4 = 'HKLF') or
    (s4 = 'REM') or (S4 = 'ANIS')  or (s4 = 'MOLE') then begin
      if (nb_atomes = 1)then begin

         readln(nomf,s4,s);
         nb_lignes:=nb_lignes+1;
         if (ioresult <> 0)then begin
           erreur('Read error at line Nb '+inttostr(nb_lignes));
           exit;
         end;

      end;
      continue;
    end;
    //if (length(s4) = 0) or (s4 = '') or (s4 = '    ') or(s4 = 'END') then break;

//Aout 2001 Gestion de PART
    if (s4 = 'PART')then begin
     s:=trim(s);
     val(s,ipart,ier);
     continue;
    end;

    if (s4 = '')then continue;
    if (s4 = 'END')then break;
    aniso:=5;
    if (pos('=',s) > 0)then begin
      delete(s,pos('=',s),1);

      readln(nomf,s1);
      nb_lignes:=nb_lignes+1;
      if (ioresult <> 0)then begin
          erreur('Read error at line Nb '+inttostr(nb_lignes));
          exit;
      end;

      aniso:=10;
      s:=s+s1;
    end;
    nb_atomes:=nb_atomes+1;

//Decodage de la chaine
    for i:=1 to 11 do valeur[i]:=0;

    dec(s,valeur,nb_valeurs,ier);
    if (ier <> 0)then begin
      erreur('Read error at line Nb '+inttostr(nb_lignes));
      exit;
    end;

    numero_sfac:=round(valeur[1]);

//Contraintes variable
    for i:=2 to aniso+1 do begin
      if (abs(valeur[i]) > 20) then begin
        m:=trunc(valeur[i]/10);
        p:=valeur[i]-m*10;
        if (m > 0)then valeur[i]:=p*fv[m] else valeur[i]:=p*fv[-m]-1;
      end;
    end;

//Blocage des coordonnes
    for i:=2 to 4 do begin
      if (abs(valeur[i]) > 2)then begin
        if (valeur[i] >= 5)then valeur[i]:=valeur[i]-10
        //else if (valeur[i] <= -10)then valeur[i]:=valeur[i]+10;
      end;
    end;

//Contraintes restantes
    for i:=2 to aniso+1 do begin
      if (abs(valeur[i]) > 10) then begin
        m:=round(valeur[i]) div 10;
        p:=valeur[i]-m*10;
        if (m > 0)then valeur[i]:=p*fv[m] else valeur[i]:=p*fv[-m]-1;
      end;
    end;

    nb_motif:=nb_motif+1;
    if (valeur[6] < 0)then valeur[6]:=-valeur[6];
    with motif[nb_motif] do begin
        s:=s4;
        nom:=uppercase(s);
        part:=ipart;
        if (nb_sfac > 0) then element:=elem_sfac[numero_sfac]
        else begin
          traite_nom_element(s);
          element:=uppercase(copy(s,1,2));
        end;
        s1:=trim(element);
        delete(s,1,length(s1));
        labell:=trim(s);
        nom:=element+labell;
        x:=valeur[2];
        y:=valeur[3];
        z:=valeur[4];
        beta[1]:=valeur[6];
        beta[2]:=valeur[7];
        beta[3]:=valeur[8];
        beta[4]:=valeur[11];
        beta[5]:=valeur[10];
        beta[6]:=valeur[9];
        if (beta[2] = 0)then iso:=1 else iso:=0;
    end;
  end;
  closeFile(nomf);
{$I+}

 (*assignFile(nomf,'coord');
  rewrite(nomf);
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      writeln(nomf,nom:4,'  ',element:2,labell:4,x:8:4,y:10:4,z:10:4,beta[1]:8:5,beta[2]:8:5,
      beta[3]:8:5,beta[4]:8:5,beta[5]:8:5,beta[6]:8:5);
    end;
  end;
  closefile(nomf); *)

// On slectionne la position triviale  (tableau tp_sel)
1:
  npos_sel:=1;
  selected[1]:=1;
  for i:=1 to 3 do
  for j:=1 to 4 do tp_sel[1,i,j]:=tp[1,i,j];
  if (nb_atomes = 0)then begin
    erreur('No atoms in the ShelX file !!!');
    nb_motif:=0;
    exit;
  end;

//Types de liaisons
  set_typ_liaisons;

end;

procedure lit_powdercell(var ier:integer);
//----------------------------------------
var
 nomf                           : textfile;
 s5                             : string[5];
 s2                             : string[2];
 s,ss,s1                        : string;
 valeur                         : tab_reel;
 i,j,k,nb_valeurs,no_groupe     : integer;
 huipi2                         : real;
 v4                             : vecteur4;
begin
    huipi2:=8*pi*pi;
//Le fichier contient-il la carte natom
    ier:=0;

//Lecture de la maille
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    while not(eof(nomf)) do begin
      read(nomf,s5,s);
      s5:=uppercase(s5);S5:=trim(s5);
      if (s5 <> 'CELL') then continue;
      for i:=1 to 11 do valeur[i]:=0;
      dec(s,valeur,nb_valeurs,ier);
      nb_motif:=0;
      if(ier = 0) then begin
        for i:=1 to 6 do cel[i]:=valeur[i];
        setmat;
        quel_systeme;
      end;
      if (ier = 1)then readln(nomf,s5); //lecture eventuelle de la carte NATOM
      break;
    end;
    closefile(nomf);

    //Lecture des atomes
    AssignFile(nomf,nom_fichier_shelx);
    reset(nomf);
    i:=0;
    while not eof(nomf) do begin
          readln(nomf,s5,s);
          s5:=uppercase(s5);
          s:=trim(s);
          s5:=trim(s5);
          if (s5 = '')then continue;
          if (s5 = 'CELL') or (s5 = 'NATOM')then continue;
          if (pos('RGNR',s5) > 0) or (pos('rgnr',s5) > 0) then break;

//Element+label
          i:=i+1;
          ss:=s5;
          traite_nom_element(ss);
          s5:=ss;
          s2:=s5;
          s2:=trim(s2);
          ier:=1;
          for j:=1 to 95 do begin
            if (s2 = elem_crom[j])then begin
              motif[i].element:=elem_crom[j];
              ier:=0;
              break;
            end;
          end;
          if (ier = 1)then begin
             j:=strtoint(trim(s5));
             motif[i].element:=elem_crom[j];
          end;
          delete(s5,1,length(motif[i].element));
          motif[i].labell:=trim(s5);
          motif[i].nom:=motif[i].element+motif[i].labell;
//x,y,z
          delete(s,1,2);
          for j:=1 to 11 do valeur[j]:=0;
          dec(s,valeur,nb_valeurs,ier);
          if (ier > 0)then continue;
          motif[i].x:=valeur[1];
          motif[i].y:=valeur[2];
          motif[i].z:=valeur[3];
          if (valeur[5] = 0)then valeur[5]:=1; // si les beta ne sont pas fournis!
          motif[i].beta[1]:=valeur[5]/(4*pi*pi);
          for k:=2 to 6 do motif[i].beta[k]:=0;
          motif[i].iso:=1;
    end;
    nb_motif:=i;
    s:=trim(s);
    val(s,no_groupe,ier);
    closefile(nomf);

//Recherche du groupe repr par son numero
      chdir(repertoire_origine);
      assignfile(nomf,'spa.grp');
      reset(nomf);
      for j:=1 to no_groupe-1 do readln(nomf);
      readln(nomf,j,s);
      groupe_espace:=copy(s,1,10);
      groupe_espace:=trim(groupe_espace);
      closefile(nomf);
      chdir(repertoire_origine);

//Recherche des positions
      bravais:=copy(groupe_espace,1,1);
      set_positions;
      for i:=1 to npos do begin
        s:='';
        for j:=1 to 3 do begin
          for k:=1 to 4 do v4[k]:=tp[i,j,k];
          code(v4,s1);
          if (j >1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
        end;
        s_pos[i]:=s;
        selected[i]:=0;
      end;

//On slectionne la position triviale
      npos_sel:=1;
      selected[1]:=1;
      s_pos[1]:=' X, Y, Z';
      for i:=1 to 3 do
      for j:=1 to 4 do begin
        tp_sel[1,i,j]:=0;
        if (i = j)then tp_sel[1,i,j]:=1;
      end;

//Type de liaison et couleurs
      set_typ_liaisons;
end;

procedure lit_poudrix(var ier:integer);
//-------------------------------------
var
 nomf                           : textfile;
 i,j,k,nb_valeurs,no_groupe     : integer;
 x1,x2,x3,x4                    : real;
 ato                            : string[4];
 lab_atome                      : string[2];
 s,s1                           : string;
 v4                             : vecteur4;
begin
  ier:=0;
  AssignFile(nomf,nom_fichier_shelx);
  reset(nomf);
  readln(nomf);
  readln(nomf,systeme);
  readln(nomf,groupe_espace);
  groupe_espace:=trim(groupe_espace);
  for i:=1 to 6 do read(nomf,cel[i]);
  setmat;
  readln(nomf);
  nb_motif:=0;
  while not(eof(nomf)) do begin
   nb_motif:=nb_motif+1;
   readln(nomf,ato,lab_atome,x1,x2,x3,x4);
   with motif[nb_motif] do begin
     element:=trim(ato);
     labell:=trim(lab_atome);
     nom:=element+labell;
     x:=x1;
     y:=x2;
     z:=x3;
     if (x4 = 0)then x4:=1;
     beta[1]:=x4/(4*pi*pi);
     for j:=2 to 6 do beta[j]:=0;
     iso:=1;
   end;
  end;
  closefile(nomf);
  chdir(repertoire_origine);

//Recherche du groupe repr par son numero
(*   chdir(repertoire_origine);
    assignfile(nomf,'spa.grp');
    reset(nomf);
    for j:=1 to no_groupe-1 do readln(nomf);
    readln(nomf,j,s);
    groupe_espace:=copy(s,1,10);
    groupe_espace:=trim(groupe_espace);
    closefile(nomf);
    chdir(repertoire_origine);
*)
//Recherche des positions
    bravais:=copy(groupe_espace,1,1);
    set_positions;
    for i:=1 to npos do begin
        s:='';
        for j:=1 to 3 do begin
          for k:=1 to 4 do v4[k]:=tp[i,j,k];
          code(v4,s1);
          if (j >1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
        end;
        s_pos[i]:=s;
        selected[i]:=0;
    end;

//On slectionne la position triviale
    npos_sel:=1;
    selected[1]:=1;
    s_pos[1]:=' X, Y, Z';
    for i:=1 to 3 do
    for j:=1 to 4 do begin
        tp_sel[1,i,j]:=0;
        if (i = j)then tp_sel[1,i,j]:=1;
    end;

//Type de liaison et couleurs
    set_typ_liaisons;
end;

procedure frac_to_dec(s:string; var x:real);
//------------------------------------------
const
  frac : array[1..11] of string =
  ('   0','   1/8','   1/6','   1/4','   1/3','   1/2','   7/8','   3/4',
  '   2/3','   5/6','    0');
  dec  : array[1..11] of real =
  (0.0  ,0.125  ,0.166667  ,    0.25, 0.333333,   0.5  ,  0.875  , 0.75   ,
  0.666667, 0.833333,1);
var
  i       : integer;
begin
  x:=0;
  s:=trim(s);
  for i:=1 to 11 do begin
     if (s = trim(frac[i]))then begin
      x:=dec[i];
      exit;
     end;
  end;
end;

procedure lit_lazyPulverix(var ier:integer);
//------------------------------------------

var
  i,j,k               : integer;
  nomf                : TextFile;
  s,s1                : string;
  valeurs             : tab_reel;
  v4                  : vecteur4;
  t                   : real;
begin
   ier:=0;
   AssignFile(nomf,nom_fichier_shelx);
   reset(nomf);
   nb_motif:=0;
   while not(eof(nomf)) do begin
      readln(nomf,s);
      if (pos('TITLE',s) > 0)then begin
        delete(s,1,pos(' ',s));
        titre:=s;
      end;
      if (pos('CELL',s) > 0)then begin
        delete(s,1,pos(' ',s));
        dec(s,valeurs,j,ier);
        if (ier = 0)then begin
          for i:=1 to 6 do cel[i]:=valeurs[i];
          setmat;
          quel_systeme;
        end else begin
          erreur('Cell not found');
          closefile(nomf);
          ier:=1;
          exit;
        end;
      end;
      if (pos('SPCGRP',s) > 0)then begin
        delete(s,1,pos(' ',s));
        while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
        groupe_espace:=s;
      end;
      if (pos('ATOM',s) > 0)then begin
        nb_motif:=nb_motif+1;
        if (nb_motif > 1000)then begin
          erreur('The number of atoms is > 1000!');
          closefile(nomf);
          chdir(repertoire_origine);
          ier:=1;
          exit;
        end;
        s1:=copy(s,5,6);
        s1:=trim(uppercase(s1));
        traite_nom_element(s1);
        motif[nb_motif].nom:=s1;
        motif[nb_motif].element:=copy(s1,1,2);
        motif[nb_motif].element:=trim(motif[nb_motif].element);
        delete(s1,1,2);
        motif[nb_motif].labell:=trim(s1);

        s:=copy(s,11,length(s)-11);
        dec(s,valeurs,i,ier);
        if (ier > 0)then begin
          erreur('Read error');
          closefile(nomf);
          ier:=1;
          exit;
        end;
        motif[nb_motif].x:=valeurs[1];
        motif[nb_motif].y:=valeurs[2];
        motif[nb_motif].z:=valeurs[3];
        if (valeurs[4] = 0) then valeurs[4]:=1;
        motif[nb_motif].beta[1]:=valeurs[4]/(4*pi*pi);
        for k:=2 to 6 do  motif[nb_motif].beta[k]:=0;
        motif[nb_motif].iso:=1;
      end;
   end;

   closefile(nomf);
   chdir(repertoire_origine);

//Recherche des positions
      bravais:=copy(groupe_espace,1,1);
      set_positions;
      for i:=1 to npos do begin
        s:='';
        for j:=1 to 3 do begin
          for k:=1 to 4 do v4[k]:=tp[i,j,k];
          code(v4,s1);
          if (j >1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
        end;
        s_pos[i]:=s;
        selected[i]:=0;
      end;

//On slectionne la position triviale
      npos_sel:=1;
      selected[1]:=1;
      s_pos[1]:=' X, Y, Z';
      for i:=1 to 3 do
      for j:=1 to 4 do begin
        tp_sel[1,i,j]:=0;
        if (i = j)then tp_sel[1,i,j]:=1;
      end;

//Type de liaison et couleurs
      set_typ_liaisons;
end;

procedure pousse_nom_atome(var s:string);
//---------------------------------------
var  i:integer;
begin
  s:=trim(s);
  if (length(s) < 4)then for i:=length(s)+1 to 4 do s:=s+' ';
end;

procedure ecrit_fichier_ascii;
//----------------------------
var
  i,j,k                        : integer;
  s                            : string;
  s1                           : string[8];
  s30,ss30                     : string[30];
  nomf                         : textfile;
  tab_flag                     : array[1..20] of integer;
  x                            : real;
begin
  assignfile(nomf,nom_fichier_sortie);
  rewrite(nomf);

  writeln(nomf,'#Title');
  writeln(nomf,titre);

  writeln(nomf,'#Cell');
  writeln(nomf,cel[1]:8:4,cel[2]:8:4,cel[3]:8:4,cel[4]:8:3,cel[5]:8:3,cel[6]:8:3);

//groupe d'espace
  writeln(nomf,'#Space group');
  writeln(nomf,groupe_espace);
  if (centre = 1)then s:='+' else s:='-';
  s:=s+bravais;
  writeln(nomf,s);

//Positions quivalentes
  writeln(nomf,'#General Positions');
  writeln(nomf,npos);
  for i:=1 to npos do begin
    for j:=1 to 3 do begin
      for k:=1 to 3 do write(nomf,tp[i,j,k]:4:0);
      write(nomf,tp[i,j,4]:10:6);
    end;
    writeln(nomf,'  ',selected[i]:4);
  end;

//Types d'lmnts
  writeln(nomf,'#Element sorts');
  writeln(nomf,nb_typ_element);
  for i:=1 to nb_typ_element do begin
    with element[i] do begin
      writeln(nomf,nom:2,' ',couleur:10,rayon:6:2);
    end;
  end;

//Maille asymtrique
  writeln(nomf,'#Asymetric unit contents');
  writeln(nomf,nb_motif);
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      s:=nom;pousse_nom_atome(s);
      writeln(nomf,s,x:10:5,y:10:5,z:10:5,no_element:5);
      write(nomf,'     ');
      for j:=1 to 6 do write(nomf,beta[j]:10:6);
      writeln(nomf);
    end;
  end;

//Atomes gnrs
  writeln(nomf,'#Generated atoms');
  writeln(nomf,nb_child);
  for i:=1 to nb_child do begin
    with child[i] do begin
      s:=nom;if (length(s) < 5)then for j:=length(s)+1 to 5 do s:=s+' ';
      s1:=slabel[i];if (length(s1) < 8) then for j:=length(s1)+1 to 8 do s1:=s1+' ';
      writeln(nomf,s,s1,x:10:5,y:10:5,z:10:5,dx:8:3,dy:8:3,part:5);
      write(nomf,'     ');
      for j:=1 to 6 do write(nomf,beta[j]:12:8);
      writeln(nomf);
      writeln(nomf,no_element:5,couleur:10,nbfrg:5,iso:5,trace:5,tlabel:5);
    end;
  end;

//Types de liaisons
  writeln(nomf,'#Bonds sorts');
  writeln(nomf,nb_typ_liai);
  for i:=1 to nb_typ_liai do begin
    with tableau_liai[i] do begin
      writeln(nomf,atome1:4,atome2:4,distance:8:2);
    end;
  end;

//Liaisons calcules
  writeln(nomf,'#Calculated bonds');
  writeln(nomf,nb_bonds);
  for i:=1 to nb_bonds do begin
    with bonds[i] do begin
      writeln(nomf,atome1:4,atome2:4,nature:4,distance:8:3,width:5,couleur:10,
      dx:8:3,dy:8:3,'  ',angle:8:3,labell);
    end;
  end;

//Matrice d'orientation
  Writeln(nomf,'#Orientation matrix');
  for i:=1 to 3 do begin
    for j:=1 to 3 do write(nomf,r03[i,j]:12:7);
    writeln(nomf);

  end;

//probabilit
  writeln(nomf,'#Ellipsoids probability');
  writeln(nomf,probabilite);

//Options de dessin
  writeln(nomf,'#Drawing options');

//Flags divers
  for i:=1 to 20 do tab_flag[i]:=0;
  tab_flag[1]:=flag_coupure;tab_flag[2]:=flag_degrade;tab_flag[3]:=flag_sommets;
  tab_flag[4]:=flag_plans;tab_flag[5]:=flag_axes;tab_flag[6]:=flag_label_centre;
  tab_flag[7]:=flag_label_shift;tab_flag[8]:=flag_fragment;tab_flag[9]:=flag_sphere;
  tab_flag[10]:=flag_boite;tab_flag[11]:=flag_cut_sphere;tab_flag[12]:=flag_cut_boite;
  tab_flag[13]:=flag_contents;tab_flag[14]:=flag_noir_blanc;
  tab_flag[15]:=fdessin.radiogroup4.itemIndex;tab_flag[16]:=flag_couleur_fragment;
  if (fdessin.CheckBox9.State = cbchecked)then tab_flag[17]:=1 else tab_flag[17]:=0;
  for i:=1 to 20 do write(nomf,tab_flag[i]:3);
  writeln(nomf,dim_du:8:2,couleur_du:12);

//Bite ou sphre
  writeln(nomf,'#Box of enclosure');
  writeln(nomf,x_arete:8:3,y_arete:8:3,z_arete:8:3);
  writeln(nomf,x_centre:8:3,y_centre:8:3,z_centre:8:3);
  writeln(nomf,'#sphere of enclosure');
  writeln(nomf,rayon_sphere:8:3);

//paramtres du trait
  writeln(nomf,'#bond width and perspective');
  x:=epaisseur*0.01;
  writeln(nomf,x:6:3);
  writeln(nomf,alfa:8:4);

//Couleurs fond et liaisons
  writeln(nomf,'#background and bonds coulours');
  writeln(nomf,coul_liai:4);
  writeln(nomf,coul_bkgrd:4);

//Fontes
  Writeln(nomf,'#Fonts name and colour');

  s30:=trim(font_name);
  write(nomf,s30);
  j:=length(s30);
  if (j < 30)then for i:=j+1 to 30 do write(nomf,' ');
  ss30:=trim(font2_name);
  writeln(nomf,ss30);

  s30:=trim(s_style);
  write(nomf,s30);
  j:=length(s30);
  if (j < 30)then for i:=j+1 to 30 do write(nomf,' ');
  ss30:=trim(s2_style);
  writeln(nomf,ss30);

  writeln(nomf,font_size:15,font_color:15,font2_size:15,font2_color:15);

  closefile(nomf);
end;

procedure lit_fichier_ascii;
//--------------------------
var
  i,j,k,ier,no                 : integer;
  x,som                        : real;
  s,s1                         : string;
  s8                           : string[8];
  s5,ch5                       : string[5];
  s2                           : string[2];
  s30,ss30                     : string[30];
  nomf                         : textfile;
  tab_flag                     : array[1..20] of integer;
  v4                           : vecteur4;
  valeurs                      : tab_reel;
begin
  assignfile(nomf,nom_fichier_ascii);
  reset(nomf);

  readln(nomf);
  readln(nomf,titre);

  readln(nomf);
  for i:=1 to 6 do read(nomf,cel[i]);
  readln(nomf);
  setmat;

  readln(nomf);   //#Space group
  readln(nomf,groupe_espace);
  quel_systeme;
  readln(nomf,s);
  if (pos('+',s) > 0) then centre:=1 else centre:=0;
  delete(s,1,1);s:=trim(s);bravais:=s;

//Positions
  readln(nomf);
  readln(nomf,npos);
  for i:=1 to npos do begin
    for j:=1 to 3 do begin
      for k:=1 to 3 do read(nomf,tp[i,j,k]);
      read(nomf,tp[i,j,4]);
    end;
    readln(nomf,selected[i]);
  end;

  for i:=1 to npos do begin
    s:='';
    for j:=1 to 3 do begin
      for k:=1 to 4 do v4[k]:=tp[i,j,k];
      code(v4,s1);
      if (j > 1)then s:=s+','+uppercase(s1) else s:=s+uppercase(s1);
    end;
    s_pos[i]:=s;
  end;

//gnration des positions slectionnes
  npos_sel:=0;
  for i:=1 to npos do begin
    if (selected[i] = 0)then continue;
    npos_sel:=npos_sel+1;
    for j:=1 to 3 do
    for k:=1 to 3 do tp_sel[npos_sel,j,k]:=tp[i,j,k];
  end;

//Sortes d'lments
  readln(nomf,s);
  readln(nomf,nb_typ_element);
  for i:=1 to nb_typ_element do begin
    with element[i] do begin
      readln(nomf,s2,couleur,rayon);
      nom:=trim(s2);
    end;
  end;

//Atomes du motif
  readln(nomf);
  readln(nomf,nb_motif);
  for i:=1 to nb_motif do begin
    with motif[i] do begin
      readln(nomf,s5,x,y,z,no_element);
      s:=s5;
      traite_nom_element(s);
      nom:=uppercase(s5) ;
      nom:=trim(nom);
      for j:=1 to 6 do read(nomf,beta[j]);
      readln(nomf);
      som:=0;
      for j:=2 to 6 do som:=som+beta[j];
      if (som = 0)then motif[i].iso:=1 else iso:=0;
    end;
  end;

//Elments et labels des atomes du motif
  for i:=1 to nb_motif do begin
      s1:=element[motif[i].no_element].nom;
      motif[i].element:=s1;
      s:=motif[i].nom;
      delete(s,1,length(s1));
      motif[i].labell:=s;
  end;

//Set d'atomes gnrs
  readln(nomf);
  readln(nomf,nb_child);
  for i:=1 to nb_child do begin
    with child[i] do begin
      readln(nomf,s5,s8,x,y,z,dx,dy);
      s:=s5;
      traite_nom_element(s);
      element:=copy(s,1,2);
      labell:=copy(s,3,3);
      nom:=trim(s5);
      for j:=1 to 6 do read(nomf,beta[j]);
      readln(nomf);
      readln(nomf,no_element,couleur,nbfrg,iso,trace,tlabel);
    end;
    slabel[i]:=trim(s8);
  end;

//Elment et label des atomes gnrs
  for i:=1 to nb_child do begin
      if (child[i].element = 'DU')then begin
        child[i].labell:='';
        continue;
      end;
      s1:=element[child[i].no_element].nom;
      child[i].element:=s1;
      s:=child[i].nom;
      delete(s,1,length(s1));
      child[i].labell:=s;
  end;

//bond sorts
  readln(nomf,s);
  readln(nomf,nb_typ_liai);
  for i:=1 to nb_typ_liai do begin
      readln(nomf,s5,ch5,x);
      tableau_liai[i].atome1:=trim(s5);tableau_liai[i].atome2:=trim(ch5);
      tableau_liai[i].distance:=x;
  end;

  readln(nomf,s);

// Liaisons
  readln(nomf,nb_bonds);
  for i:=1 to nb_bonds do begin
    with bonds[i] do begin
      //readln(nomf,atome1,atome2,nature,distance);
      readln(nomf,s1);
      s:=copy(s1,1,61);
      dec(s,valeurs,no,ier);
      atome1:=round(valeurs[1]);
      atome2:=round(valeurs[2]);
      nature:=round(valeurs[3]);
      distance:=valeurs[4];
      dx:=valeurs[7];
      dy:=valeurs[8];
      angle:=valeurs[9];
      s:=copy(s1,62,25);
      labell:=trim(s);
      if (no = 4)then begin
        width:=6;
        couleur:=coul_liai;
      end else begin
        width:=round(valeurs[5]);
        couleur:=round(valeurs[6]);
      end;
    end;
  end;

//*Orientation matrix
  readln(nomf);
  for i:=1 to 3 do begin
    for j:=1 to 3 do read(nomf,r03[i,j]);
    readln(nomf);
  end;
  matinv(r03,r30,i);
  mat_mult(r20,r03,r23);
  mat_mult(r30,r02,r32);
  mat_mult(r12,r23,r13);
  mat_mult(r32,r21,r31);


  readln(nomf);
  readln(nomf,probabilite);

  readln(nomf);
  for i:=1 to 20 do tab_flag[i]:=0;
  for i:=1 to 20 do read(nomf,tab_flag[i]);
  readln(nomf,s);
  s:=trim(s);
  if (s = '')then begin
    dim_du:=0.01;
    couleur_du:=16744576;
  end else begin
    s:=trim(s);
    s1:=copy(s,1,pos(' ',s));
    s1:=trim(s1);
    val(s1,dim_du,ier);
    delete(s,1,pos(' ',s));
    s:=trim(s);
    couleur_du:=strtoint(s);
  end;

  flag_coupure:=tab_flag[1];flag_degrade:=tab_flag[2];flag_sommets:=tab_flag[3];
  flag_plans:=tab_flag[4];flag_axes:=tab_flag[5];flag_label_centre:=tab_flag[6];
  flag_label_shift:=tab_flag[7];flag_fragment:=tab_flag[8];flag_sphere:=tab_flag[9];
  flag_boite:=tab_flag[10];flag_cut_sphere:=tab_flag[11];flag_cut_boite:=tab_flag[12];
  flag_contents:=tab_flag[13];flag_noir_blanc:=tab_flag[14];
  fdessin.RadioGroup4.itemIndex:=tab_flag[15];flag_couleur_fragment:=tab_flag[16];
  flag_ecrit_labels_bond:=tab_flag[17];

  readln(nomf);
  readln(nomf,x_arete,y_arete,z_arete);
  readln(nomf,x_centre,y_centre,z_centre);
  readln(nomf);
  readln(nomf,rayon_sphere);

//paramtres du trait
  readln(nomf);
  readln(nomf,s);
  dec(s,valeurs,no,ier);
  x:=valeurs[1];
  if (x < 1)then epaisseur:=round(x/0.01) else epaisseur:=round(x);
//readln(nomf,epaisseur);
  readln(nomf,alfa);

//Couleurs fond et liaisons
  readln(nomf);
  readln(nomf,coul_liai);
  readln(nomf,coul_bkgrd);

//Fontes
  readln(nomf);
  readln(nomf,font_name);
  readln(nomf,s30,ss30);
  s_style:=s30;
  s2_style:=ss30;
  if (s2_style = '')then s2_style:=s_style;

  readln(nomf,s);
  dec(s,valeurs,no,ier);
  font_size:=round(valeurs[1]);
  font_color:=round(valeurs[2]);
  if (no > 2)then begin
    font2_size:=round(valeurs[3]);
    font2_color:=round(valeurs[4]);
  end else begin
    font2_size:=font_size;
    font2_color:=font_color;
  end;
//  readln(nomf,font_size,font_color);

  closefile(nomf);
end;

procedure ecrit_fichier_shelx;
//----------------------------
var
  nomf,nom           : TextFile;
  i,j,k,nlat,n       : integer;
  c4                 : string[4];
  s2,s22             : string[2];
  s11                : string[11];
  s                  : string;
  const
  ct   : array[1..7] of string[4]=
  ('1/2','1/3','2/3','1/4','3/4','1/6','5/6');
  vt   : array[1..7] of string =
  ('0.5','0.3333333','0.6666667','0.25','0.75','0.166667','0.83333');
begin
  assignFile(nomf,nom_fichier_sortie);
  rewrite(nomf);
//TITL
  writeln(nomf,'TITL ',nomstruc);
//CELL
  if (lambda = 0)then lambda:=0.7106;
  write(nomf,'CELL ',lambda:8:5);for i:=1 to 6 do write(nomf,cel[i]:10:4);
  writeln(nomf);
  writeln(nomf,'ERR ',nb_motif:5,' 0 0 0 0 0');

//LATT
  if (bravais = 'P')then nlat:=1;
  if (bravais = 'I')then nlat:=2;
  if (bravais = 'R') and (systeme = 'RHOM') then nlat:=1;
  if (bravais = 'R') and (systeme = 'HEXA') then nlat:=3;
  if (bravais = 'F')then nlat:=4;
  if (bravais = 'A')then nlat:=5;
  if (bravais = 'B')then nlat:=6;
  if (bravais = 'C')then nlat:=7;
  if (centre <> 1)then nlat:=-nlat;
  writeln(nomf,'LATT ',nlat);

//SYMM
(*  if (centre <> 0)then n:=npos else n:=npos div 2;
  if (bravais = 'F')then n:=n*4;
  if (bravais = 'I') or (bravais = 'A') or (bravais = 'B') or (bravais = 'C')
  then n:=n*2;
  if (bravais = 'R') and (systeme = 'HEXA') then n:=n div 3; *)
  if (groupe_espace = '')then begin
    for i:=2 to npos do begin
      s:=s_pos[i];
      for j:=1 to 7 do begin
        repeat
          k:=pos(ct[j],s);
          if(k > 0)then begin
            delete(s,k,3);
            insert(vt[j],s,k);
          end;
        until k=0;
      end;
      writeln(nomf,'SYMM ',s);
    end;
  end else begin

    if (fmainmenu.listbox2.itemindex > -1)then begin
//On relit dans le fichier *.pos les positions gnratrices
      s:=trim(systeme)+'.pos';
      chdir(repertoire_origine);
      AssignFile(nom,s);
      reset(nom);
      while not(eof(nom)) do begin
        readln(nom,s);
        s:=trimRight(s);
        if (s = groupe_espace)then begin
          readln(nom);
          readln(nom,n);
          for i:=1 to n do begin
            readln(nom,s);
            s:=ansiuppercase(s);
            for j:=1 to 7 do begin
              repeat
                k:=pos(ct[j],s);
                if(k > 0)then begin
                 delete(s,k,3);
                 insert(vt[j],s,k);
                end;
              until k=0;
            end;
            writeln(nomf,'SYMM ',s);
          end;
          break;
        end;
      end;
      closefile(nom);

    end else if (fmainmenu.listbox3.itemindex > -1)then begin
      chdir(repertoire_origine);
      AssignFile(nom,'scfs.dat');
      reset(nom);
      while not(eof(nom)) do begin
        readln(nom,s);
        if (pos('Symmetry Operators',s) > 0)then begin
          readln(nom);
          break;
        end;
      end;

      while not(eof(nom)) do begin
        readln(nom,s11,s);
        s:=trim(s);
        if (s11 = '')then break;
        if (s = '-X,-Y,-Z')then break;
        for j:=1 to 7 do begin
          repeat
            k:=pos(ct[j],s);
            if(k > 0)then begin
               delete(s,k,3);
               insert(vt[j],s,k);
            end;
          until k=0;
        end;
        writeln(nomf,'SYMM ',s);
      end;
      closefile(nom);
    end;

  end;

//SFAC
  write(nomf,'SFAC ');
  for i:=1 to nb_typ_element do write(nomf,element[i].nom,' ');
  writeln(nomf);

//UNIT
  write(nomf,'UNIT ');
  for i:=1 to nb_typ_element do begin
    n:=0;
    s22:=element[i].nom;s22:=trim(s22);
    for j:=1 to nb_motif do begin
      s2:=copy(motif[j].nom,1,2);s2:=trim(s2);s2:=uppercase(s2);
      if (s2 = s22)then begin
        n:=n+1;
      end;
    end;
    write(nomf,n:3);
  end;
  writeln(nomf);

//FVAR
  writeln(nomf,'FVAR     1');

//Atom cards
  For i:=1 to nb_motif do begin
    with motif[i] do begin
      c4:=trim(nom);
      if (length(c4) < 4)then for j:=length(c4)+1 to 4 do c4:=c4+' ';
      if (beta[2] = 0)then
      writeln(nomf,c4,no_element:4,x:10:5,y:10:5,z:10:5,'   11.0000',beta[1]:10:5)
      else begin
        writeln(nomf,c4,no_element:4,x:10:5,y:10:5,z:10:5,'   11.0000',
        beta[1]:10:5,beta[2]:10:5,'   =');
        writeln(nomf,beta[3]:10:5,beta[6]:10:5,beta[5]:10:5,beta[4]:10:5);
      end;
    end;
  end;
  writeln(nomf,'END');
  closefile(nomf);

end;
//----------------------------------------------------------------------------
{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
begin
  while (pos(' .',s) > 0)do begin
    insert('0',s,pos(' .',s)+1);
  end;
  while (pos(' -.',s) > 0)do begin
    insert('0',s,pos(' -.',s)+2);
  end;
end;

procedure decode_cif_atomes(var s,label_atome:string; var x,y,z,t :real);
//-----------------------------------------------------------------------
var
  ier,i,no                      : integer;
  tableau                      : tab_reel;
  s1                           : string;
begin
  s1:=s;
  verif(s1);
  i:=pos(' ',s1);
  label_atome:=copy(s1,1,i-1);label_atome:=trim(label_atome);
  delete(s1,1,i-1);
  while (pos('(',s1) > 0) do delete(s1,pos('(',s1),pos(')',s1)-pos('(',s1)+1);
  s1:=trim(s1);
  dec(s1,tableau,no,ier);
  x:=tableau[1];
  y:=tableau[2];
  z:=tableau[3];
  t:=tableau[4];
end;

procedure calcul_u_equivalent(var b : tab6; var ueq: real);
//---------------------------------------------------------
var
  t,v                       : tab6;
  i                         : integer;
begin
   t[1]:=sqr(cel[1]);t[2]:=sqr(cel[2]);t[3]:=sqr(cel[3]);
   t[4]:=cel[1]*cel[2]*cos(cel[6]/57.2957);
   t[5]:=cel[3]*cel[1]*cos(cel[5]/57.2957);
   t[6]:=cel[2]*cel[3]*cos(cel[4]/57.2957);
   v[1]:=celr[1]*celr[1];
   v[2]:=celr[2]*celr[2];
   v[3]:=celr[3]*celr[3];
   v[4]:=celr[1]*celr[2]*cos(celr[6]/57.2957);
   v[5]:=celr[1]*celr[3]*cos(celr[5]/57.2957);
   v[6]:=celr[2]*celr[3]*cos(celr[4]/57.2957);
   ueq:=0;
   for i:=1 to 6 do ueq:=ueq+b[i]*t[i]*v[i];
   ueq:=ueq/3;
end;

Procedure trouve_groupe(var  s1,s2: string);
//------------------------------------------
const
h_m1 : array[1..230] of string[12]= (
'P1          ','P-1         ','P2          ','P21         ','C2          ','PM          ','PC          ',
'CM          ','CC          ','P2/M        ','P21/M       ','C2/M        ','P2/C        ','P21/C       ',
'C2/C        ','P222        ','C222        ','P2221       ','F222        ','P21212      ','I222        ',
'P212121     ','C2221       ','I212121     ','PMM2        ','PMC21       ','PCC2        ','PMA2        ',
'PCA21       ','PNC2        ','PMN21       ','PBA2        ','PNA21       ','PNN2        ','CMM2        ',
'CMC21       ','CCC2        ','AMM2        ','ABM2        ','AMA2        ','ABA2        ','FMM2        ',
'FDD2        ','IMM2        ','IBA2        ','IMA2        ','PMMM        ','PNNN        ','PCCM        ',
'PBAN        ','PMMA        ','PNNA        ','PMNA        ','PCCA        ','PBAM        ','PCCN        ',
'PBCM        ','PNNM        ','PMMN        ','PBCN        ','PBCA        ','PNMA        ','CMCM        ',
'CMCA        ','CMMM        ','CCCM        ','CMMA        ','CCCA        ','FMMM        ','FDDD        ',
'IMMM        ','IBAM        ','IBCA        ','IMMA        ','P4          ','P41         ','P42         ',
'P43         ','I4          ','I41         ','P-4         ','I-4         ','P4/M        ','P42/M       ',
'P4/N        ','P42/N       ','I4/M        ','I41/A       ','P422        ','P4212       ','P4122       ',
'P41212      ','P4222       ','P42212      ','P4322       ','P43212      ','I422        ','I4122       ',
'P4MM        ','P4BM        ','P42CM       ','P42NM       ','P4CC        ','P4NC        ','P42MC       ',
'P42BC       ','I4MM        ','I4CM        ','I41MD       ','I41CD       ','P-42M       ','P-42C       ',
'P-421M      ','P-421C      ','P-4M2       ','P-4C2       ','P-4B2       ','P-4N2       ','I-4M2       ',
'I-4C2       ','I-42M       ','I-42D       ','P4/MMM      ','P4/MCC      ','P4/NBM      ','P4/NNC      ',
'P4/MBM      ','P4/MNC      ','P4/NMM      ','P4/NCC      ','P42/MMC     ','P42/MCM     ','P42/NBC     ',
'P42/NNM     ','P42/MBC     ','P42/MNM     ','P42/NMC     ','P42/NCM     ','I4/MMM      ','I4/MCM      ',
'I41/AMD     ','I41/ACD     ','P3          ','P32         ','P31         ','R3          ','P-3         ',
'R-3         ','P312        ','P321        ','P3112       ','P3121       ','P3212       ','P3221       ',
'R32         ','P3M1        ','P31M        ','P3C1        ','P31C        ','R3M         ','R3C         ',
'P-31M       ','P-31C       ','P-3M1       ','P-3C1       ','R-3M        ','R-3C        ','P6          ',
'P61         ','P65         ','P62         ','P64         ','P63         ','P-6         ','P6/M        ',
'P63/M       ','P622        ','P6122       ','P6522       ','P6222       ','P6422       ','P6322       ',
'P6MM        ','P6CC        ','P63CM       ','P63MC       ','P-6M2       ','P-6C2       ','P-62M       ',
'P-62C       ','P6/MMM      ','P6/MCC      ','P63/MCM     ','P63/MMC     ','P23         ','F23         ',
'I23         ','P213        ','I213        ','PM3         ','PN3         ','FM3         ','FD3         ',
'IM3         ','PA3         ','IA3         ','P432        ','P4232       ','F432        ','F4132       ',
'I432        ','P4332       ','P4132       ','I4132       ','P-43M       ','F-43M       ','I-43M       ',
'P-43N       ','F-43C       ','I-43D       ','PM3M        ','PN3N        ','PM3N        ','PN3M        ',
'FM3M        ','FM3C        ','FD3M        ','FD3C        ','IM3M        ','IA3D        ');

h_m2 : array[1..230] of string[17] = (
'P 1         ','P -1        ','P 2         ','P 21        ','C 2         ','P M         ',
'P C         ','C M         ','C C         ','P 2/M       ','P 21/M      ','C 2/M       ',
'P 2/C       ','P 21/C      ','C 2/C       ','P 2 2 2     ','C 2 2 2    ','P 2 2 21    ',
'F 2 2 2     ','P 21 21 2   ','I 2 2 2     ','P 21 21 21  ','C 2 2 21    ','I 21 21 21  ',
'P M M 2     ','P M C 21    ','P C C 2     ','P M A 2     ','P C A 21    ','P N C 2     ',
'P M N 21    ','P B A 2     ','P N A 21    ','P N N 2     ','C M M 2     ','C M C 21    ',
'C C C 2     ','A M M 2     ','A B M 2     ','A M A 2     ','A B A 2     ','F M M 2     ',
'F D D 2     ','I M M 2     ','I B A 2     ','I M A 2     ','P M M M     ','P N N N     ',
'P C C M     ','P B A N     ','P M M A     ','P N N A     ','P M N A     ','P C C A     ',
'P B A M     ','P C C N     ','P B C M     ','P N N M     ','P M M N     ','P B C N     ',
'P B C A     ','P N M A     ','C M C M     ','C M C A     ','C M M M     ','C C C M     ',
'C M M A     ','C C C A     ','F M M M     ','F D D D     ','I M M M     ','I B A M     ',
'I B C A     ','I M M A     ','P 4         ','P 41        ','P 42        ','P 43        ',
'I 4         ','I 41        ','P -4        ','I -4        ','P 4/M       ','P 42/M      ',
'P 4/N       ','P 42/N      ','I 4/M       ','I 41/A      ','P 4 2 2     ','P 4 21 2    ',
'P 41 2 2    ','P 41 21 2   ','P 42 2 2    ','P 42 21 2   ','P 43 2 2    ','P 43 21 2   ',
'I 4 2 2     ','I 41 2 2    ','P 4 M M     ','P 4 B M     ','P 42 C M    ','P 42 N M    ',
'P 4 C C     ','P 4 N C     ','P 42 M C    ','P 42 B C    ','I 4 M M     ','I 4 C M     ',
'I 41 M D    ','I 41 C D    ','P -4 2 M    ','P -4 2 C    ','P -4 21 M   ','P -4 21 C   ',
'P -4 M 2    ','P -4 C 2    ','P -4 B 2    ','P -4 N 2    ','I -4 M 2    ','I -4 C 2    ',
'I -4 2 M','I -4 2 D    ','P 4/M M M   ','P 4/M C C   ','P 4/N B M   ','P 4/N N C   ',
'P 4/M B M   ','P 4/M N C   ','P 4/N M M   ','P 4/N C C   ','P 42/M M C  ','P 42/M CM   ',
'P 42/N B C  ','P 42/N N M  ','P 42/M B C  ','P 42/M N M  ','P 42/N M C  ','P 42/N C M  ',
'I 4/M M M   ','I 4/M C M   ','I 41/A M D  ','I 41/A C D  ','P 3         ','P 32        ',
'P 31        ','R 3         ','P -3        ','R -3        ','P 3 1 2     ','P 3 2 1     ',
'P 31 1 2    ','P 31 2 1    ','P 32 1 2    ','P 32 2 1    ','R 3 2       ','P 3 M 1     ',
'P 3 1 M     ','P 3 C 1     ','P 3 1 C     ','R 3 M       ','R 3 C       ','P -3 1 M    ',
'P -3 1 C    ','P -3 M 1    ','P -3 C 1    ','R -3 M','R -3 C      ','P 6         ',
'P 61        ','P 65        ','P 62        ','P 64        ','P 63        ','P -6        ',
'P 6/M       ','P 63/M      ','P 6 2 2     ','P 61 2 2    ','P 65 2 2    ','P 62 2 2    ',
'P 64 2 2    ','P 63 2 2    ','P 6 M M     ','P 6 C C     ','P 63 C M    ','P 63 M C    ',
'P -6 M 2    ','P -6 C 2    ','P -6 2 M    ','P -6 2 C    ','P 6/M M M   ','P 6/M C C   ',
'P 63/M C M  ','P 63/M M C  ','P 2 3       ','F 2 3       ','I 2 3       ','P 21 3      ',
'I 21 3      ','P M 3       ','P N 3       ','F M 3       ','F D 3       ','I M 3       ',
'P A 3       ','I A 3       ','P 4 3 2     ','P 42 3 2    ','F 4 3 2     ','F 41 3 2    ',
'I 4 3 2     ','P 43 3 2    ','P 41 3 2    ','I 41 3 2    ','P -4 3 M    ','F -4 3 M    ',
'I -4 3 M    ','P -4 3 N    ','F -4 3 C    ','I -4 3 D    ','P M 3 M     ','P N 3 N     ',
'P M 3 N     ','P N 3 M     ','F M 3 M     ','F M 3 C     ','F D 3 M     ','F D 3 C     ',
'I M 3 M     ','I A 3 D     ');
var
  c1,c2 : string;
  i     : integer;
begin
  c1:=trim(s1);
  c1:=uppercase(c1);
  c2:='';
  for i:=1 to 230 do begin
    c2:=h_m1[i];
    c2:=trim(c2);
    if (c2 = s1)then begin
      s2:=trim(h_m2[i]);
      exit;
    end;
  end;
end;

procedure convertit_atome_label(var s:string);
//------------------------------------------
var
  s1          : string;
begin
 s1:=lowercase(s);
 if (s[2] <> ' ')then s[2]:=s1[2];
 if (s[2] = ' ')then delete(s,2,1);
end;

procedure calcule_formule;
//------------------------
var
  s,s1,s2                  : string;
  i,j,n                    : integer;
  symbole                  : array[1..10] of string[2];
  indice                   : array[1..10] of integer;
begin
    s:='';
    for i:=1 to nb_typ_element do begin
      n:=0;
      s1:=element[i].nom;
      s1:=trim(uppercase(s1));
      for j:=1 to nb_motif do begin
        s2:=motif[j].nom;
        traite_nom_element(s2);
        s2:=copy(s2,1,2);
        s2:=trim(uppercase(s2));
        if (s2 = s1)then begin
          n:=n+1;
        end;
      end;
      symbole[i]:=s1;
      indice[i]:=n;
    end;
    //s:=''''+trim(s)+'''';
    s2:='C';
    for i:=1 to nb_typ_element do begin
      s1:=trim(symbole[i]);
      if (s1 = '') then continue;
      if (s1 = s2)then begin
         s:=s+s1+inttostr(indice[i])+' ';
         symbole[i]:='';
      end;
    end;
    s2:='H';
    for i:=1 to nb_typ_element do begin
      s1:=trim(symbole[i]);
      if (s1 = '') then continue;
      if (s1 = s2)then begin
         s:=s+s1+inttostr(indice[i])+' ';
         symbole[i]:='';
      end;
    end;
    s2:='N';
    for i:=1 to nb_typ_element do begin
      s1:=trim(symbole[i]);
      if (s1 = '') then continue;
      if (s1 = s2)then begin
         s:=s+s1+inttostr(indice[i])+' ';
         symbole[i]:='';
      end;
    end;
    s2:='O';
    for i:=1 to nb_typ_element do begin
      s1:=trim(symbole[i]);
      if (s1 = '') then continue;
      if (s1 = s2)then begin
        s:=s+s1+inttostr(indice[i])+' ';
        symbole[i]:='';
      end;
    end;

    for i:=1 to nb_typ_element do begin
      if (symbole[i] <> '')then s:=s+symbole[i]+inttostr(indice[i])+' ';
    end;
    formule:=''''+trim(s)+'''';
end;

procedure ecrit_fichier_cif;
//--------------------------
var
   s,s1,s2,nom1,nom2,nom3                         : string;
   i,j,k,n,i1,i2,i3,i4,j1,j2,j3,j4,l,nb_aniso,ier : integer;
   at1,at2,at3                                    : integer;
   b                                              : tab6;
   ueq,d1,d2,som                                  : real;
   xo1,yo1,zo1,xo2,yo2,zo2,d,ang                  : double;
   nomi,nomj                                      : string[2];
   nomf                                           : textfile;

begin
  assignFile(nomf,nom_fichier_sortie);
  rewrite(nomf);
  writeln(nomf,'data_block1');
  if (formule = '')then calcule_formule;
  writeln(nomf,'_chemical_formula_sum   '+formule);

//maille
  str(cel[1]:10:4,s);
  writeln(nomf,'_cell_length_a                  ',s);
  str(cel[2]:10:4,s);
  writeln(nomf,'_cell_length_b                  ',s);
  str(cel[3]:10:4,s);
  writeln(nomf,'_cell_length_c                  ',s);
  str(cel[4]:10:2,s);
  writeln(nomf,'_cell_angle_alpha               ',s);
  str(cel[5]:10:2,s);
  writeln(nomf,'_cell_angle_beta                ',s);
  str(cel[6]:10:2,s);
  writeln(nomf,'_cell_angle_gamma               ',s);
  writeln(nomf,'_cell_formula_units_Z           ',nombre_z);

//Symmtrie
  if (systeme = 'CUBI')then s:='Cubic';
  if (systeme = 'TETR')then s:='Tetragonal';
  if (systeme = 'ORTH')then s:='Orthorhombic';
  if (systeme = 'HEXA')then s:='Hexagonal';
  if (systeme = 'RHOM')then s:='Rhomboedral';
  if (systeme = 'MONO')then s:='Monoclinic';
  if (systeme = 'TRIC')then s:='Triclinic';
  writeln(nomf,'_symmetry_cell_setting          ',s);

  writeln(nomf,'loop_');
  writeln(nomf, '          _symmetry_equiv_pos_as_xyz  ');
  for i:=1 to npos do begin
    s:=s_pos[i];
    writeln(nomf,'         ','''',s,'''');
  end;
  writeln(nomf);

//groupe d'espace
  s1:='';
  with fmainmenu do begin
    if (groupe_espace <> '')then begin
      s1:=uppercase(groupe_espace);
      if (s1 <> '')then begin
        if (listbox2.itemindex <> -1)then begin
          s2:=listbox2.items[listbox2.itemindex];
          trouve_groupe(s2,s);
          writeln(nomf,'_symmetry_space_group_name_H-M   ','''',trim(s),'''');
          writeln(nomf);
        end else if (listbox3.itemindex <> -1)then begin
          s2:=listbox3.items[listbox3.itemindex];
          delete(s2,1,pos(' ',s2));
          s2:=trim(s2);
          s2:=copy(s2,1,15);
          s2:=trim(s2);
          s2:=''''+s2+'''';
          writeln(nomf,'_symmetry_space_group_name_Hall  ',s2);
          writeln(nomf);
        end;
      end;
    end;
  end;

//Coordonnes et Uequ
  writeln(nomf,'loop_');
  s:='_atom_site_label';
  writeln(nomf,s);
  s:='_atom_site_fract_x';
  writeln(nomf,s);
  s:='_atom_site_fract_y';
  writeln(nomf,s);
  s:='_atom_site_fract_z';
  writeln(nomf,s);
  s:='_atom_site_U_iso_or_equiv';
  writeln(nomf,s);
  s:='_atom_site_adp_type';
  writeln(nomf,s);
  nb_aniso:=0;
  for i:=1 to nb_motif do begin
    with motif[i] do begin

//Vrification de iso
      som:=0;
      for j:=2 to 6 do som:=som+beta[j];
      if (som = 0)then iso:=1 else iso:=0;

      if (iso = 0)then nb_aniso:=nb_aniso+1;
      s:=nom;
      convertit_atome_label(s);
      while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
      if (iso = 0)then begin
        for j:=1 to 6 do b[j]:=beta[j];
        calcul_u_equivalent(b,ueq);
        write(nomf,s);
        if (length(s) < 4)then for k:=length(s)+1 to 4 do write(nomf,' ');
        write(nomf,'  ',x:10:5,y:10:5,z:10:5,ueq:10:5);
        writeln(nomf,'  Uani');
      end else begin
        write(nomf,s);
        if (length(s) < 4)then for k:=length(s)+1 to 4 do write(nomf,' ');
        write(nomf,'  ',x:10:5,y:10:5,z:10:5,beta[1]:10:5);
        writeln(nomf,'  Uiso');
      end;
    end;
  end;
  writeln(nomf);

//Uij aniso
  if (nb_aniso > 0)then begin
    writeln(nomf,'loop_');
    s:='_atom_site_aniso_label';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_11';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_22';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_33';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_12';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_13';
    writeln(nomf,s);
    s:='_atom_site_aniso_U_23';
    writeln(nomf,s);
    for i:=1 to nb_motif do begin
      with motif[i] do begin
        if (iso = 1)then continue;
        s:=nom;
        convertit_atome_label(s);
        while (pos(' ',s) > 0) do delete(s,pos(' ',s),1);
        write(nomf,s);
        if (length(s) < 4)then for k:=length(s)+1 to 4 do write(nomf,' ');
        write(nomf,'  ');
        for j:=1 to 6 do write(nomf,beta[j]:10:5);
        writeln(nomf);
      end;
    end;
  end;

//Calcul et ecriture des liaisons calcules par Gretep

//Liaisons
  if (nb_bonds = 0) and (fformula.radiogroup1.itemIndex = 0) and (flag_brown = 0)then begin
    erreur ('No calculated bonds! Plot the structure');
    writeln(nomf);
    writeln(nomf);
    closefile(nomf);
    exit;
  end;

//******************************************************************************

if (flag_brown = 0)then begin

  if (nb_child > 0) and (nb_bonds > 0) and (fformula.radiogroup1.itemIndex = 0)then begin
    set_code_positions;
    writeln(nomf);
    writeln(nomf,'loop_');
    writeln(nomf,' _geom_bond_atom_site_label_1');
    writeln(nomf,' _geom_bond_atom_site_label_2');
    writeln(nomf,' _geom_bond_distance');
    writeln(nomf,' _geom_bond_site_symmetry_1');
    writeln(nomf,' _geom_bond_site_symmetry_2');

    for k:=1 to nb_bonds do begin
      with bonds[k] do begin
        i:=atome1;
        j:=atome2 ;
        d:=distance;

//Ecriture
        nom1:=child[i].nom;
        nom2:=child[j].nom;
        traite_nom_atome(nom1);
        traite_nom_atome(nom2);
        write(nomf,nom1);
        if (length(nom1) < 4) then for l:=length(nom1)+1 to 4 do write(nomf,' ');
        write(nomf,' ',nom2);
        if (length(nom2) < 4) then for l:=length(nom2)+1 to 4 do write(nomf,' ');
        write(nomf,' ',d:8:3,' ');
        writeln(nomf,
        '  ',i1234[i,1],'_',i1234[i,2],i1234[i,3],i1234[i,4],
        '  ',i1234[j,1],'_',i1234[j,2],i1234[j,3],i1234[j,4]);
      end;
    end;

//Angles

//Y a-t-il des angles  crire?
    ier:=1;
    for i:=1 to nb_bonds-1 do begin      // atome milieu
      at1:=bonds[i].atome1;
      at2:=bonds[i].atome2;
      for j:= i+1 to nb_bonds do begin
        if      (bonds[j].atome1 = at1) then at3:=bonds[j].atome2
        else if (bonds[j].atome2 = at1) then at3:=bonds[j].atome1
        else continue;
        d1:=bonds[i].distance;
        d2:=bonds[j].distance;
        if (d1 = 0) or (d2 = 0)then continue;
        ier:=0;
      end;
    end;

    if (ier = 0)then begin
      writeln(nomf);
      writeln(nomf,'loop_');
      writeln(nomf,' _geom_angle_atom_site_label_1');
      writeln(nomf,' _geom_angle_atom_site_label_2');
      writeln(nomf,' _geom_angle_atom_site_label_3');
      writeln(nomf,' _geom_angle');
      writeln(nomf,' _geom_angle_site_symmetry_1');
      writeln(nomf,' _geom_angle_site_symmetry_2');
      writeln(nomf,' _geom_angle_site_symmetry_3');
      for i:=1 to nb_bonds-1 do begin      // atome milieu
        at1:=bonds[i].atome1;
        at2:=bonds[i].atome2;
        for j:= i+1 to nb_bonds do begin
          if      (bonds[j].atome1 = at1) then at3:=bonds[j].atome2
          else if (bonds[j].atome2 = at1) then at3:=bonds[j].atome1
          else continue;
          d1:=bonds[i].distance;
          d2:=bonds[j].distance;
          if (d1 = 0) or (d2 = 0)then continue;

//calcul de l'angle
          xo1:=xorth[at1]-xorth[at2];
          yo1:=yorth[at1]-yorth[at2];
          zo1:=zorth[at1]-zorth[at2];
          xo2:=xorth[at1]-xorth[at3];
          yo2:=yorth[at1]-yorth[at3];
          zo2:=zorth[at1]-zorth[at3];
          ang:=57.2957*arccos((xo1*xo2+yo1*yo2+zo1*zo2)/(d1*d2));

//Ecriture
          nom1:=child[at1].nom;
          nom2:=child[at2].nom;
          nom3:=child[at3].nom;
          traite_nom_atome(nom1);
          traite_nom_atome(nom2);
          traite_nom_atome(nom3);
          write(nomf,nom2);
          if (length(nom2) < 4) then for l:=length(nom2)+1 to 4 do write(nomf,' ');
          write(nomf,' ',nom1);
          if (length(nom1) < 4) then for l:=length(nom1)+1 to 4 do write(nomf,' ');
          write(nomf,' ',nom3);
          if (length(nom3) < 4) then for l:=length(nom3)+1 to 4 do write(nomf,' ');
          write(nomf,ang:8:3);
          writeln(nomf,
          '  ',i1234[at2,1],'_',i1234[at2,2],i1234[at2,3],i1234[at2,4],
          '  ',i1234[at1,1],'_',i1234[at1,2],i1234[at1,3],i1234[at1,4],
          '  ',i1234[at3,1],'_',i1234[at3,2],i1234[at3,3],i1234[at3,4]);
        end;
      end;
    end;
  end;

//******************************************************************************
End else begin
  writeln(nomf);
  writeln(nomf,'loop_');
  writeln(nomf,' _geom_bond_atom_site_label_1');
  writeln(nomf,' _geom_bond_atom_site_label_2');
  writeln(nomf,' _geom_bond_distance');
  writeln(nomf,' _geom_bond_site_symmetry_1');
  writeln(nomf,' _geom_bond_site_symmetry_2');
  for i:= 1 to nb_lignes_brown do begin
    s:=trim(fbrown.memo2.lines[i-1]);
    if (s = '') or (pos('Angle',s) > 0) then continue;
    s1:=copy(s,1,18);
    s2:=copy(s,47,7);
    if (pos(')',s2) > 0)then delete(s2,pos(')',s2),1);
    s:=s1+'  1_555   '+s2;
    s:=trim(s);
    writeln(nomf,s);
  end;
  if (fbrown.radiogroup1.itemIndex = 1)then begin
      writeln(nomf);
      writeln(nomf,'loop_');
      writeln(nomf,' _geom_angle_atom_site_label_1');
      writeln(nomf,' _geom_angle_atom_site_label_2');
      writeln(nomf,' _geom_angle_atom_site_label_3');
      writeln(nomf,' _geom_angle');
      writeln(nomf,' _geom_angle_site_symmetry_1');
      writeln(nomf,' _geom_angle_site_symmetry_2');
      writeln(nomf,' _geom_angle_site_symmetry_3');
      for i:= 1 to nb_lignes_brown do begin
        s:=trim(fbrown.memo2.lines[i-1]);
        if (s = '') or (pos('Angle',s) = 0) then continue;
        s:=copy(s,8,56);
        writeln(nomf,s);
      end;
  end;
  fformula.radiogroup1.visible:=true;
  fformula.label2.visible:=true;
end;
//******************************************************************************

  writeln(nomf);
  writeln(nomf);
  closefile(nomf);
end;

end.

