(*procedure inter1(i : integer;xo,yo,zo,p,q,r : real;var t1,t2 :real);
//-------------------------------------------------------------------------
//Intersection de la droite x=xo+p*t,y=yo+y*t,z=zo+r*t avec l'ellipsode no i
//Retourne t1 et t2.
var
  ax,bx,cx,delta,t          : real;
begin
    t1:=0;t2:=0;
    ax:=bb[i,1,1]*p*p+bb[i,2,2]*q*q+bb[i,3,3]*r*r+
       2*(bb[i,1,2]*p*q+bb[i,1,3]*r*p+bb[i,2,3]*q*r);
    bx:=2*(bb[i,1,1]*xo*p+bb[i,2,2]*yo*q+bb[i,3,3]*zo*r+
       bb[i,1,2]*(xo*q+yo*p)+bb[i,1,3]*(xo*r+zo*p)+bb[i,2,3]*(yo*r+zo*q));
    cx:=bb[i,1,1]*xo*xo+bb[i,2,2]*yo*yo+bb[i,3,3]*zo*zo+
       2*(bb[i,1,2]*xo*yo+bb[i,1,3]*xo*zo+bb[i,2,3]*yo*zo)-1;
    delta:=bx*bx-4*ax*cx;
    if (delta <= 0)then begin
      //t:=0;
      exit;
    end;
    delta:=sqrt(delta);
    t1:=(-bx-delta)/(2*ax);
    t2:=(-bx+delta)/(2*ax);
    if (t1 > t2) then begin
      t:=t2;
      t2:=t1;
      t1:=t;
    end;
end;

procedure inter2(i : integer; xo,yo,p,q:real; var t1,t2 :real);
//------------------------------------------------------------
//Intersection de la droite x=xo+p*t,y=yo+y*t dans le plan de projection avec le
//contour de l'ellipsode numero i.
var
  ax,bx,cx,delta ,t          : real;
begin
  t1:=0;t2:=0;
  ax:=k1[i]*p*p + k2[i]*q*q + k3[i]*p*q;
  bx:=2*k1[i]*xo*p+2*k2[i]*yo*q+k3[i]*(xo*q+yo*p);
  cx:=k1[i]*xo*xo+k2[i]*yo*yo+k3[i]*xo*yo-k4[i];
  delta:=bx*bx-4*ax*cx;
  if (delta <= 0)then exit;
  delta:=sqrt(delta);
  t1:=(-bx-delta)/(2*ax);
  t2:=(-bx+delta)/(2*ax);
  if (t1 > t2) then begin
      t:=t2;
      t2:=t1;
      t1:=t;
  end;
end;

procedure cote(i : integer; xo,yo:real; var z1,z2 :real);
//-------------------------------------------------------
//Intersection de la droite verticale passant par xo,yo, avec l'ellipsode
var
  ax,bx,cx,delta,z          : real;
begin
  z1:=0;z2:=0;
  ax:=bb[i,3,3];
  bx:=2*(bb[i,1,3]*xo+bb[i,2,3]*yo);
  cx:=bb[i,1,1]*xo*xo+bb[i,2,2]*yo*yo+2*bb[i,1,2]*xo*yo-1;
  if (ax < 1e-16)then begin
    if (bx > 1e-16)then begin
      z1:=-cx/bx;
      z2:=z1;
    end;
  end;
  delta:=bx*bx-4*ax*cx;
  if (delta < 0)then exit;
  delta:=sqrt(delta);
  z1:=(-bx-delta)/(2*ax);
  z2:=(-bx+delta)/(2*ax);
  if (z1 > z2) then begin
    z:=z2;
    z2:=z1;
    z1:=z;
  end;
end; *)

procedure trace2pr(num1,num2,n1,n2,nature:integer;p,q,r:real);
//----------------------------------------------------------
//Trac de l'atome n1  l'atome n2 sur le trajet num1  num2
var
 i,j,k                                        : integer;
 ix,iy                                        : array[1..42] of integer;
//coord des dbuts des traits autour de num1
 dx,dy,dz                                     : array[1..21] of real;
//contour
 tabxy                                        : array[1..42] of tpoint;
 xo,yo,zo,x,y,z                               : real;
 d,d2,phiy,phiz                               : real;
 t1,t2,t                                      : real;
 pl,ql,rl,delta ,tg_alfa,xk                   : real;
 s2                                           : string[2];

 dist_num1_num2,dist_num1_n1,dist_num1_n2     : real;
begin
  d:=epaisseur;
  s2:=child[num1].nom;s2:=trim(s2);s2:=uppercase(s2);
  if (s2 = 'H') then d:=d/3;
  s2:=child[num2].nom;s2:=trim(s2);s2:=uppercase(s2);
  if (s2 = 'H') then d:=d/3;

  d2:=d*d;
  tg_alfa:=tan(alfa/57.2957);

  dist_num1_num2:=sqrt(p*p+q*q+r*r);
  dist_num1_n1:=sqrt(sqr(xstk[num1]-xstk[n1])+sqr(ystk[num1]-ystk[n1]));
  dist_num1_n2:=sqrt(sqr(xstk[num1]-xstk[n2])+sqr(ystk[num1]-ystk[n2]));
  delta:=dist_num1_num2*tg_alfa;

//coord. des dbuts de trait sur num1
  for i:=1 to 21 do begin
     yo:=d-(i-1)*d/10 ;
     zo:=-sqrt(abs(d2-yo*yo));
     xo:=0;
     phiy:=arctan2(r,p);
     x:=xo*cos(phiy)+zo*sin(phiy);
     z:=-xo*sin(phiy)+zo*cos(phiy);
     y:=yo;
     phiz:=arctan2(q,p);
     dx[i]:=x*cos(phiz)-y*sin(phiz);
     dy[i]:=x*sin(phiz)+y*cos(phiz);
     dz[i]:=abs(z);
  end;

//contour sur l'atome n1
  for i:=1 to 21 do begin
     xk:=(1-dist_num1_n1*tg_alfa);
     xo:=dx[i]*xk;
     yo:=dy[i]*xk;
    // zo:=dz[i]*xk;
     pl:=p-delta*xo;
     ql:=q-delta*yo;
     //rl:=r-delta*zo;

//origine sur l'atome n1
     xo:=xo+xstk[num1]-xstk[n1];
     yo:=yo+ystk[num1]-ystk[n1];
     //zo:=zo+zstk[num1]-zstk[n1];
     inter2(n1,xo,yo,pl,ql,t1,t2);
     if (t1 = 0)and (t2 = 0)then exit;
     if (t2 <> 0)then t:=t2 else  t:=-(pl*xo+ql*yo)/(pl*pl+ql*ql);

     x:=xstk[n1]+xo+pl*t;
     y:=ystk[n1]+yo+ql*t;
     ix[i]:=ixo+round(x*echelle);
     iy[i]:=iyo-round(y*echelle);
  end;

//contour sur l'atome n2
  for i:=1 to 21 do begin
     xk:=(1-dist_num1_n2*tg_alfa);
     xo:=dx[i]*xk;
     yo:=dy[i]*xk;
     zo:=dz[i]*xk;
     pl:=p-delta*xo;
     ql:=q-delta*yo;
     rl:=r-delta*zo;

//origine sur l'atome n2
     xo:=xo+xstk[num1]-xstk[n2];
     yo:=yo+ystk[num1]-ystk[n2];
     zo:=zo+zstk[num1]-zstk[n2];
     inter1(n2,xo,yo,zo,pl,ql,rl,t1,t2);
     if (t1 = 0) and (t2 = 0)then inter2(n2,xo,yo,pl,ql,t1,t2);
     if (t1 <> 0)then t:=t1 else t:=-(pl*xo+ql*yo)/(pl*pl+ql*ql);

//origine dessin
     x:=xstk[n2]+xo+pl*t;
     y:=ystk[n2]+yo+ql*t;
     ix[43-i]:=ixo+round(x*echelle);
     iy[43-i]:=iyo-round(y*echelle);
  end;

  for k:= 1 to 42 do begin
    i:=ix[k];
    j:=iy[k];
    tabxy[k]:=point(i,j);
  end;

  with TMetaFileCanvas.Create(MyMetaFile,0) do
    try
      draw(0,0,MyMetaFile);
      MyMetaFile.MMwidth:=1024;
      MyMetaFile.MMheight:=1024;
      case nature of
        0:brush.color:=coul_liai;
        1:brush.color:=clgreen;
        2:brush.color:=clblue;
      end;
      Polygon(tabxy);
   (* if (nature = 1) or (nature = 3) then begin
      moveto(ix[11],iy[11]);
      lineto(ix[32],iy[32]);
    end;
    if (nature = 3)then begin
      moveto(ix[6],iy[6]);
      lineto(ix[36],iy[36]);
      moveto(ix[16],iy[16]);
      lineto(ix[27],iy[27]);
    end;
    if (nature = 2)then begin
      moveto(ix[8],iy[8]);
      lineto(ix[34],iy[34]);
      moveto(ix[14],iy[14]);
      lineto(ix[29],iy[29]);
    end;  *)
    finally
      free;
    end;

end;

procedure liaisonpr(n1,n2,nature  : integer);
//-----------------------------------------
//trace une liaison entre l'atome 1 et l'atome 2
type coupure = record
  t                                     : real;
  no_t,ind                              : integer;
end;

var
 num1,num2                                    : integer;
 x1,y1,z1,x2,y2,z2,x,y,z                      : real;
 xo1,yo1,zo1,xo2,yo2,zo2                      : real;

 i,j,k,n,m                                    : integer;

//coupures
 p,q,r,t1,t2,tt1,tt2,tau1,tau2,tmin,tmax      : real;
 nb_t                                         : integer;
 coup                                         : array[1..50] of coupure;
 dum                                          : coupure;

//Contour
 flag_contour                                 : integer;

 zz1,zz2                                      : real;

begin
  //writeln(nomesp,'Liaison ',nom_atg[n1],' ',nom_atg[n2]);

  with fdessin.image1.canvas do begin
    for i:=1 to 50 do begin
      coup[i].ind:=0;
      coup[i].no_t:=0;
      coup[i].t:=0;
    end;

//Lequel des 2 atomes est-il dessus?
    if (zstk[n1] >= zstk[n2])then begin
      num1:=n1;
      num2:=n2;
    end else begin
      num1:=n2;
      num2:=n1;
    end;
    x1:=xstk[num1];    y1:=ystk[num1];    z1:=zstk[num1];
    x2:=xstk[num2];    y2:=ystk[num2];    z2:=zstk[num2];
    p:=x2-x1;          q:=y2-y1;          r:=z2-z1;
    xo1:=0;            yo1:=0;            zo1:=0;

//Atome de dpart
    x:=0;
    y:=0;
    inter2(num1,x,y,p,q,t1,t2);
    if (t1 = 0) and (t2 = 0) then exit;
    tmin:=t2;

    //atome d'arrive
    x:=x1-xstk[num2];
    y:=y1-ystk[num2];
    z:=z1-zstk[num2];
    inter1(num2,x,y,z,p,q,r,tt1,tt2);
    tmax:=tt1;
    if (tmin >tmax)then exit;      //recouvrement

    nb_t:=0;
    for i:=1 to nb_child do begin
        if (i = num1) or (i = num2)then begin



        x:=x1-xstk[i];
        y:=y1-ystk[i];

//Coupure du contour
        inter2(i,x,y,p,q,t1,t2);
        if (t1 = 0) and (t2 = 0)then continue;              // Pas de coupure

// Recouvrement?
        if (i <> num1) and (i <> num2)then begin
            if (t1 < tmin) and (t2 > tmax)then exit;
        end;
        tau1:=t1;
        tau2:=t2;

//Coupure de l'ellipsode
        x:=x1-xstk[i];
        y:=y1-ystk[i];
        z:=z1-zstk[i];
        inter1(i,x,y,z,p,q,r,tt1,tt2);

//Le contour coup est-il au dessous de la droite?
        if (tt1 = 0) and (tt2 = 0)then begin
          x:=x1+t2*p-xstk[i];
          y:=y1+t2*q-ystk[i];
          z:=z1+t2*r-zstk[i];
          cote(i,x,y,zz1,zz2);
          if ( zz2 < z )then continue;
        end;
        if (tt2 <> 0)then tau2:=tt2;

        if (tau1 > 1) or  (tau2 < 0)then continue;            // Coup en dehors
        //sortie
        if (tau1 > 0) and (tau1 < 1)then begin
          nb_t:=nb_t+1;
          coup[nb_t].t:=tau1;
          coup[nb_t].no_t:=i;
          coup[nb_t].ind:=2;
        end;
//entre
        if (tau2 > 0) and (tau2 < 1)then begin
          nb_t:=nb_t+1;
          coup[nb_t].t:=tau2;
          coup[nb_t].no_t:=i;
          coup[nb_t].ind:=1;
        end;
        end;
    end;

//Rangement
    for i:=1 to nb_t-1 do begin
        for j:=i+1 to nb_t do begin
          if (coup[i].t > coup[j].t) then begin
            dum:=coup[i];
            coup[i]:=coup[j];
            coup[j]:=dum;
          end;
        end;
    end;

//Trac
    i:=1;
    while(i < nb_t)do begin
        if (coup[i].ind = 1) and (coup[i+1].ind = 2)then begin
          //j:=coup[i].no_t;
          k:=coup[i+1].no_t;
          trace2pr(num1,num2,coup[i].no_t,coup[i+1].no_t,nature,p,q,r);
        end;
        i:=i+1;
    end;

  end;

end;

