{Bibliothque pour DESMOL}
Unit oemath;

Interface

Uses
  SysUtils, WinTypes, WinProcs, Messages,
  Controls, StdCtrls, dialogs, math, graphics;

type atomes = record
  nom                                            : string[6];
  labell                                         : string[4];
  element                                        : string[4];
  x,y,z,dx,dy                                    : double;
  beta                                           : array[1..6] of double;
  no_element,couleur,nbfrg,iso,trace,tlabel,part : integer;
end;

type typ_liaisons = record
   atome1 : string[2];
   atome2 : string[2];
   distance : double;
end;

type liai = record
   atome1 : integer;
   atome2 : integer;
   nature,couleur,width : integer;
   distance,dx,dy,angle : double;
   labell   : string[25];
end;

type elem = record
   couleur     : integer;
   rayon       : double;
   nom         : string[2];
end;

type
  matrice3                         = array[1..3,1..3] of double ;
  vecteur3                         = array[1..3] of double;
  vecteur4                         = array[1..4] of double;
  tab_reel                         = array[1..12] of double;
  tab_mess                         = array[1..16] of integer;

const
  pir         = 57.2957;

var
  repertoire_origine                   : string;
  coul_liai,coul_bkgrd,coul_scalebar   : integer;
  //nomf                               : TextFile;
  nomesp                               : textFile;

  px_cm                                       : double;
  s_style,s2_style                            : string;
//fontes labels atome
  font_name                                   : string;
  font_size ,font_color                       : integer;
  font_style                                  : TFontstyles;
//Fontes labels bonds
  font2_name                                  : string;
  font2_size ,font2_color                     : integer;
  font2_style                                 : TFontstyles;

  {Noms}
  nomstruc                                : string;
  nom_fichier_shelx                       : string;
  nom_fichier_grt                         : string;
  nom_fichier_sortie                      : string;
  nom_fichier_ascii                       : string;
  nom_fichier_wmf                         : string;
  type_fichier_shelx                      : integer;

  {Maille}
  cel,celr                                : array[1..6] of double;

  //Tableau des positions
  tp                                      : array[1..192,1..3,1..4]of double;
  s_pos                                   : array[1..192] of string[24];
  npos,npos_gene                          : integer;
  tx,ty,tz                                : array[1..4] of double;
  nbtrans                                 : integer;

  {Tableau des positions slectionnes}
  tp_sel                                  : array[1..192,1..3,1..4] of double;
  npos_sel                                : integer;
  selected                                : array[1..192] of integer;

  //Atomes du motif asymtrique
  motif ,motif_old                        : array[1..1000] of atomes;
  nb_motif,nb_motif_old                   : integer;

  //Atomes gnrs
  child,child_old                          : array[1..5000] of atomes;
  nb_child,nb_child_old                    : integer;
  //dx_label,dy_label                        : array[1..2000] of double;
  x_arete,y_arete,z_arete                  : double;
  x_centre,y_centre,z_centre               : double;
  x_coordinance,y_coordinance,z_coordinance: double;
  rayon_sphere,rayon_coordinance           : double;
  no_atome_coordinance                     : integer;
  xstk,ystk,zstk                           : array[1..5000] of double;
  slabel                                   : array[1..5000] of string[25];
  //blabel                                 : array[1..5000] of string[30];

  //fragments
  nb_fragments                             : integer;

  //Types d'lments
  element                                 : array[1..93] of elem;
  nb_typ_element                          : integer;

  //Type de liaisons
  tableau_liai                            : array[1..1000] of typ_liaisons;
  nb_typ_liai                             : integer;

  //Dummy atome
  dim_du                                  : double;
  couleur_du                              : integer;

  //Liaisons tablies
  bonds                                   : array[1..10000] of liai;
  nb_bonds                                : SmallInt;

  {Matrices}
  r10,r01,r21,r12,r13,r31,r23,r32,r20,r02 : matrice3;
  r30,r03                                 : matrice3;

  //Agitation thermique
  probabilite                             : integer;

  //Diagonalisation
  vecteur_propre                           : array[1..5000,1..3,1..3] of double;
  valeur_propre                            : array[1..5000,1..3] of double;
  b_quad                                   : array[1..5000,1..3,1..3] of double;
  vp_min,vp_max                            : double;

  //flags divers generation
  flag_cut_boite,flag_cut_sphere,flag_contents             : integer;
  flag_fragment,flag_sphere,flag_boite                     : integer;
  flag_modif_data ,flag_couleur_fragment                   : integer;
  //flags dessin
  flag_sommets,flag_plans,flag_axes,flag_distance          : integer;
  flag_coupure,flag_degrade,flag_direction                 : integer;

  flag_tlabel,flag_label_shift,flag_fenetre_label          : integer;
  flag_label_centre,flag_delete_label,flag_kill_bonds      : integer;
  
  flag_angle                                               : integer;
  flag_milieu                                              : integer;
  flag_cust_bond                                           : integer;
  flag_ecrit_labels_bond                                   : integer;

  flag_noir_blanc,flag_killbond,flag_plan_moyen            : integer;
  flag_tue_atome,flag_coordinance,flag_tue_fragment        : integer;

  flag_brown                                               : integer;

  shunte_init                                     : integer;
  chemin                                          : string;

  {epaisseur,}alfa                                : double;
   epaisseur                                      : integer;
   modif_cell,modif_coord,modif_positions         : integer;

  det_mat                                         : double;

//Variables communes concernant le cristal
   a,b,c,alpha,beta,gamma,lambda           : double;
   ca,cb,cc,ae,be,ce,cae,cbe,cce           : double ;
   ibrav,centre,nb_groupes,
   nb_groupes_getspec                      : integer;
   systeme,groupe_espace,titre,formule     : string;
   nombre_z                                : integer;
   bravais                                 : string[1];

//Flag pour modifier fdessin.checkbox3.state sans passer par fdessin.ecrit_labels
//en fait, entre et ressort sans modif
   saute : integer;

 (* palett : array[1..15] of tcolor =
  (clred,clgray,cllime,clgreen,clteal,clyellow,claqua,clmaroon,clolive,
  clsilver, clpurple,clfuchsia,clred,$F7E0B2,clyellow); *)

  const
  elem_crom: array[1..95] of string[2]=(
     'H','HE','LI','BE','B','C','N','O','F','NE',
     'NA','MG','AL','SI','P','S','CL','AR','K','CA',
     'SC','TI','V','CR','MN','FE','CO','NI','CU','ZN',
     'GA','GE','AS','SE','BR','KR','RB','SR','Y','ZR',
     'NB','MO','TC','RU','RH','PD','AG','CD','IN','SN',
     'SB','TE','I','XE','CS','BA','LA','CE','PR','ND',
     'PM','SM','EU','GD','TB','DY','HO','ER','TM','YB',
     'LU','HF','TA','W','RE','OS','IR','PT','AU','HG',
     'TL','PB','BI','PO','AT','RN','FR','RA','AC','TH',
     'PA','U','NP','D','DU');
  var palett : array[1..95] of integer= (
     clred,clred,clwhite,clwhite,clsilver,clgray,clgreen,cllime,clfuchsia,clwhite,
     clyellow,clwhite,clwhite,clblue,clpurple,clyellow,clteal,clwhite,clwhite,clblue,
     clwhite,clwhite,clgray,clsilver,clpurple,clmaroon,clgreen,clblue,clteal,clgray,
     clwhite,clwhite,clwhite,clsilver,clfuchsia,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,clwhite,
     clwhite,clwhite,clwhite,clred,clred);
     couleurs_old                                       : array[1..95] of integer;
     coul_bkgrd_old,coul_liai_old,coul_scalebar_old     : integer;

     coul_frag : array[1..14] of integer = (clred,clblue,clgreen,cllime,clyellow,clfuchsia,
     clpurple,clteal,clgray,clmaroon,clsilver,claqua,clolive,clnavy);
     nb_fragm                             : integer;
     coul_frag_name : array[1..14] of string[10] = ('clred','clblue','clgreen',
     'cllime','clyellow','clfuchsia','clpurple','clteal','clgray','clmaroon',
     'clsilver','claqua','clolive','clnavy');


(*  const
elements : array[1..15] of string[2] =
  ( 'H',   'C',   'O',    'N',   'F',    'S',   'CL',    'FE',   'CO',
    'NI',  'I',   'BR',   'CU',  'P',    'Al'); *)

function uptrim(var s:string): string;
procedure add_zero(var s:string);
function  Det      (Mat:matrice3): double;
procedure matinv   (Mat : matrice3; var mati :matrice3; var ier:integer);
Procedure ident    (mat : matrice3; var mati :matrice3);
procedure trspo    (var mat : matrice3);
procedure trfo     (u1,u2,u3: double; var v1,v2,v3 : double; var r : matrice3);
procedure trfo2    (var u1,u2,u3 : double; var r : matrice3);
procedure trfo3    (var v : vecteur3; var r : matrice3);
procedure mat_mult (ma,mb : matrice3; var mc : matrice3);
Procedure prodvec  (x,y: vecteur3; var z :vecteur3);
procedure verif    (var s:string);

procedure setmat;
procedure wr            (var nomf:TextFile; s:string; Mat:matrice3);
procedure norm          (var p,q,r : double);
procedure normd         (var x,y,z : double);
procedure normr         (var x,y,z : double);
procedure rot           (p0,q0,r0  : double; icas:integer);
Procedure erreur        (s:string);
Procedure traite_nom_element(var s:string);
procedure traite_nom_atome(var s:string);
procedure set_typ_liaisons;
Procedure calcmat(var rpqr :matrice3; var ier:integer);
procedure conditionne_matrice;
procedure teste_fichier_unix(var nom:string);
procedure attribue_couleur;
procedure quel_systeme;
procedure teste_matrice_beta(var bet:matrice3; var ier:integer);

implementation
{R+}

procedure set_typ_elements;
//-------------------------
var
  s2                     : string[2];
  s                      : string;
  i,j,ier                : integer;
  ray                    : double;
  nomfich                : TextFile;
begin
  //s:=copy(motif[1].nom,1,2);
  s:=motif[1].element;
  element[1].nom:=uptrim(s);
  nb_typ_element:=1;
  motif[1].no_element:=1;
  for i:=2 to nb_motif do begin
    //s:=copy(motif[i].nom,1,2);
    s:=motif[i].element;
    s2:=uptrim(s);
    ier:=0;
    for j:=1 to nb_typ_element do begin
      if (s2 = element[j].nom)then begin
        ier:=1;
        break;
      end;
    end;
    if (ier = 0)then begin
      nb_typ_element:=nb_typ_element+1;
      element[nb_typ_element].nom:=s2;
    end;
  end;
  for i:=1 to nb_motif do begin
    s:=motif[i].element;
    s2:=uptrim(s);
    for j:=1 to nb_typ_element do begin
      if (element[j].nom = s2) then begin
        motif[i].no_element:=j;
        break;
      end;
    end;
  end;
  
//Lecture des rayons
  s:=repertoire_origine+'\rayons.cst';
  assignFile(nomfich,s);
  reset(nomfich);
  while not eof(nomfich) do begin
    readln(nomfich,s);
    readln(nomfich,ray);
    s2:=uptrim(s);
    for i:=1 to nb_typ_element do begin
      s:=element[i].nom;
      if (s = s2)then begin
        element[i].rayon:=ray;
        break;
      end;
    end;
  end;
  closeFile(nomfich);

//Affectation des couleurs
  if(nom_fichier_grt <> '')then exit;
  coul_liai:=clyellow;
  coul_bkgrd:=clwhite;
  coul_liai_old:=clyellow;
  coul_bkgrd_old:=clwhite;
  for i:=1 to nb_typ_element do begin
    s2:=element[i].nom;
    ier:=1;
    for j:=1 to 95 do begin
      if (s2 = elem_crom[j])then begin
        element[i].couleur:=palett[j];
        couleurs_old[i]:=palett[j];
        ier:=0;
        break;
      end;
    end;
    if(ier = 1)then begin
      element[i].couleur:=clwhite;
      couleurs_old[i]:=clwhite;
    end;
  end;
end;

{Etablissement des types de liaisons}
procedure set_typ_liaisons;{
----------------------------}
var
  i,j                   : integer;
  s2                    : string[2];
  s                     : string;
begin
  set_typ_elements;
  nb_typ_liai:=0;
  for i:=1 to nb_typ_element do begin
    for j:= i to nb_typ_element do begin
       nb_typ_liai:=nb_typ_liai+1;
       with tableau_liai[nb_typ_liai] do begin
         atome1:=trim(element[i].nom);
         atome2:=trim(element[j].nom);
         distance:=1.2*(element[i].rayon+element[j].rayon);
       end;
    end;
  end;

  //Set des no d'lment des atomes du motif
  if (nb_motif > 0) then begin
    for i:=1 to nb_motif do begin
      //s:=copy(motif[i].nom,1,2);
      s:=motif[i].element;
      s2:=uptrim(s);
      for j:=1 to nb_typ_liai do begin
        if (element[j].nom = s2) then begin
          motif[i].no_element:=j;
          break;
        end;
      end;
    end;
  end;
end;


procedure add_zero(var s:string);{
---------------------------------}
begin
   if(s = '')then s:='0';
   if(s[length(s)] = '.') then s:=s+'0';
end;

function  Det      (Mat:matrice3): double;{
----------------------------------------}
begin
  det:=mat[1,1]*(mat[2,2]*mat[3,3]-mat[3,2]*mat[2,3])
      -mat[1,2]*(mat[2,1]*mat[3,3]-mat[3,1]*mat[2,3])
      +mat[1,3]*(mat[2,1]*mat[3,2]-mat[3,1]*mat[2,2]);
end;

{Inversion de matrice}
procedure matinv   (Mat : matrice3; var Mati : matrice3; var ier:integer);{
---------------------------------------------------------------------------}
var
  i,j      : integer;

begin
  ier:=0;
  mati[1,1]:=mat[2,2]*mat[3,3]-mat[2,3]*mat[3,2];
  mati[1,2]:=mat[1,3]*mat[3,2]-mat[1,2]*mat[3,3];
  mati[1,3]:=mat[1,2]*mat[2,3]-mat[1,3]*mat[2,2];

  mati[2,1]:=mat[2,3]*mat[3,1]-mat[2,1]*mat[3,3];
  mati[2,2]:=mat[1,1]*mat[3,3]-mat[1,3]*mat[3,1];
  mati[2,3]:=mat[1,3]*mat[2,1]-mat[1,1]*mat[2,3];

  mati[3,1]:=mat[2,1]*mat[3,2]-mat[2,2]*mat[3,1];
  mati[3,2]:=mat[1,2]*mat[3,1]-mat[1,1]*mat[3,2];
  mati[3,3]:=mat[1,1]*mat[2,2]-mat[1,2]*mat[2,1];

  det_mat:=det(Mat);
  if(abs(det_mat) < 1.0e-15)then begin
    ier:=1;
//    erreur('Matrice singulire');
    exit;
  end;
  For i:=1 to 3 do begin
    For j:= 1 to 3 do begin
      mati[i,j]:= mati[i,j]/det_mat;
    end;
  end;
end;

Procedure ident (mat : matrice3; var mati :matrice3);{
-----------------------------------------------------}
var i,j  :integer;
begin
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mati[i,j]:=mat[i,j];
    end;
  end;
end;

procedure trspo    (var mat : matrice3);{
----------------------------------------}
var
  i,j  :integer;
  mati :matrice3;
begin
  ident(mat,mati);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
      mat[i,j]:=mati[j,i];
    end;
  end;
end;

procedure trfo (u1,u2,u3: double; var v1,v2,v3 : double; var r : matrice3);{
-----------------------------------------------------------------------}
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
end;

procedure trfo2(var u1,u2,u3 : double; var r : matrice3);{
-------------------------------------------------------}
var
  v1,v2,v3  : double;
begin
  v1:=u1*r[1,1]+u2*r[1,2]+u3*r[1,3];
  v2:=u1*r[2,1]+u2*r[2,2]+u3*r[2,3];
  v3:=u1*r[3,1]+u2*r[3,2]+u3*r[3,3];
  u1:=v1;
  u2:=v2;
  u3:=v3
end;

procedure trfo3(var v : vecteur3; var r : matrice3);{
----------------------------------------------------}
var
  v1,v2,v3  : double;
begin
  v1:=v[1]*r[1,1]+v[2]*r[1,2]+v[3]*r[1,3];
  v2:=v[1]*r[2,1]+v[2]*r[2,2]+v[3]*r[2,3];
  v3:=v[1]*r[3,1]+v[2]*r[3,2]+v[3]*r[3,3];
  v[1]:=v1;
  v[2]:=v2;
  v[3]:=v3;
end;

{Produit vectoriel}
Procedure prodvec(x,y: vecteur3; var z :vecteur3);{
--------------------------------------------------}
begin
   z[1]:=x[2]*y[3]-x[3]*y[2];
   z[2]:=x[3]*y[1]-x[1]*y[3];
   z[3]:=x[1]*y[2]-x[2]*y[1];
end;

{Multiplication de matrices}
procedure mat_mult (ma,mb: matrice3; var mc : matrice3);{
--------------------------------------------------------}
var
  i,j,k :integer;
begin
  for k:=1 to 3 do begin
    for j:=1 to 3 do begin
      mc[j,k]:=0;
      for i:=1 to 3 do begin
        mc[j,k]:=mc[j,k]+ma[j,i]*mb[i,k];
      end;
    end;
  end;
end;

{Calcul des diffrentes matrices}
procedure setmat;{
-----------------}
var
  //a,b,c,alpha,beta,gamma                  : double;
      sa,sb,sc,{sae,}sbe,sce               :double;
      q,v                                  :double;
      i,j,ier                              :integer;
      aux                                  :matrice3;
begin
      for i:=1 to 3 do
      for j:=1 to 3 do begin
        r01[i,j]:=0;
        r10[i,j]:=0;
        r02[i,j]:=0;
        r20[i,j]:=0;
        r03[i,j]:=0;
        r30[i,j]:=0;
        r32[i,j]:=0;
        r23[i,j]:=0;
        r31[i,j]:=0;
        r13[i,j]:=0;
      end;

      a:=cel[1];
      b:=cel[2];
      c:=cel[3];
      alpha:=cel[4];
      beta:=cel[5];
      gamma:=cel[6];
      ca:=cos(cel[4]/pir);
      cb:=cos(cel[5]/pir);
      cc:=cos(cel[6]/pir);
      sa:=sin(cel[4]/pir);
      sb:=sin(cel[5]/pir);
      sc:=sin(cel[6]/pir);
      q:=1.-ca*ca-cb*cb-cc*cc+2.*ca*cb*cc;
      v:=a*b*c*sqrt(q);
      celr[1]:=b*c*sa/v;
      celr[2]:=c*a*sb/v;
      celr[3]:=a*b*sc/v;
      cae:=(cb*cc-ca)/(sb*sc);
      cbe:=(cc*ca-cb)/(sc*sa);
      cce:=(ca*cb-cc)/(sa*sb);
      celr[4]:=arccos(cae);
      celr[4]:=celr[4]*pir;
      celr[5]:=arccos(cbe);
      sbe:=sin(celr[5]);
      celr[5]:=celr[5]*pir;
      celr[6]:=arccos(cce);
      sce:=sin(celr[6]);
      celr[6]:=celr[6]*pir;
      ae:=celr[1];
      be:=celr[2];
      ce:=celr[3];

{-----Calcul de la matrice de passage du r.r. au res. rl et inversemt}
      r01[1,1]:=ae*ae;
      r01[1,2]:=ae*be*cce;
      r01[1,3]:=ae*ce*cbe;
      r01[2,2]:=be*be;
      r01[2,3]:=ce*be*cae;
      r01[3,3]:=ce*ce;

      r10[1,1]:=a*a;
      r10[1,2]:=a*b*cc;
      r10[1,3]:=a*c*cb;
      r10[2,2]:=b*b;
      r10[2,3]:=c*b*ca;
      r10[3,3]:=c*c;

      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r01[j,i]:=r01[i,j];
          r10[j,i]:=r10[i,j];
        end;
      end;

{-----Orthonormalisation du rseau rciproque R21}
      for i:=1 to 3 do begin
        for j:=1 to 3 do begin
          r21[i,j]:=0.;
        end;
      end;
      r21[1,1]:=celr[1];
      r21[1,2]:=celr[2]*cce;
      r21[1,3]:=celr[3]*cbe;
      r21[2,2]:=celr[2]*sce;
      r21[2,3]:=-celr[3]*sbe*ca;
      r21[3,3]:=1./cel[3];

{-----Orthonormalisation du rseau direct R20}
      matinv(r21,r12,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 889');
     halt;
   end;
      mat_mult(r21,r10,r20);
      mat_mult(r01,r12,r02);
      mat_mult(r01,r10,aux);

{-----Matrices R03 et R30 de dpart}
      for i:=1 to 3 do begin
       for j:=1 to 3 do begin
          r23[i,j]:=0;
          r32[i,j]:=0;
          if (i = j) then begin
            r23[i,j]:=1;
            r32[i,j]:=1;
          end;
       end;
      end;
      mat_mult(r02,r23,r03);
      {r23=r32!}
      mat_mult(r23,r20,r30);
  end;

procedure wr       (var nomf:TextFile; s:string; Mat:matrice3);{
-------------------------------------------------------------------}
var
  i,j  : integer;
begin
  writeln(nomf,s);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
     write(nomf,mat[i,j]:12:8);
    end;
    writeln(nomf);
  end;
end;

procedure lit (var nomf:TextFile; var Mat:matrice3);{
----------------------------------------------------}
var
  i,j  : integer;
  s    : string;
begin
  readln(nomf,s);
  for i:=1 to 3 do begin
    for j:=1 to 3 do begin
     read(nomf,mat[i,j]);
    end;
    readln(nomf);
  end;
end;

{Normalisation d'un vecteur dans l'espace orthonorm}
procedure norm(var p,q,r : double);{
---------------------------------}
var
  x : double;
begin
  x:=sqrt(p*p+q*q+r*r);
  p:=p/x;
  q:=q/x;
  r:=r/x;
end;

{Normalisation dans l'espace direct}
procedure normd(var x,y,z:double);{
--------------------------------}
var
  den : double;

begin
   den:=sqrt(x*x*a*a+y*y*b*b+z*z*c*c+2*(x*y*a*b*cc+y*z*b*c*ca+z*x*c*a*cb));
   x:=x/den;
   y:=y/den;
   z:=z/den;
end;

{Normalisation dans l'espace rciproque}
procedure normr(var x,y,z:double);{
--------------------------------}
var
  den : double;
begin
  den:=sqrt(x*x*ae*ae+y*y*be*be+z*z*ce*ce+
  2*(x*y*ae*be*cce+y*z*be*ce*cae+z*x*ce*ae*cbe));
  x:=x/den;
  y:=y/den;
  z:=z/den;
end;

{Calcul de la matrice connaissant seulement le icas(me) vecteur}
procedure rot(p0,q0,r0: double; icas:integer);{
--------------------------------------------}
var
  p,q,r,racine                            : double;
  i,j,ier                                 : integer;

begin
   trfo(p0,q0,r0,p,q,r,r20);
   norm(p,q,r);

   for i:=1 to 3 do begin
     for j:=1 to 3 do begin
       r32[i,j]:=0;
     end;
   end;

{P,Q,R sur X }
    if(icas = 1)then begin
      racine:=sqrt(r*r+q*q);
      if (racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if (racine >= 0.0001)then begin
        r32[1,1]:=p;
        r32[1,2]:=q;
        r32[1,3]:=r;
        r32[2,1]:=0;
        r32[2,2]:=-r/racine;
        r32[2,3]:=q/racine;
        r32[3,1]:=racine;
        r32[3,2]:=-p*q/racine;
        r32[3,3]:=-p*r/racine;
      end;
    end;

{p,p,r sur Y}
    if(icas = 2)then begin
      racine:=sqrt(p*p+r*r);
      if(racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if(racine >= 0.0001) then begin
        r32[1,1]:=-p*q/racine;
        r32[1,2]:=racine;
        r32[1,3]:=-q*r/racine;
        r32[2,1]:=p;
        r32[2,2]:=q ;
        r32[2,3]:=r;
        r32[3,1]:=r/racine ;
        r32[3,2]:=0;
        r32[3,3]:=-p/racine;
      end;
    end;

{p,p,r sur Z }
    if(icas = 3)then begin
      racine:=sqrt(p*p+q*q);
      if( racine < 0.0001)then begin
        for i:=1 to 3 do begin
          for j:=1 to 3 do begin
            r32[i,j]:=0;
          end;
          r32[i,i]:=1;
        end;
      end;
      if( racine >= 0.0001)then begin
        r32[1,1]:=q/racine;
        r32[1,2]:=-p/racine;
        r32[1,3]:=0;
        r32[2,1]:=p*r/racine;
        r32[2,2]:=q*r/racine;
        r32[2,3]:=-racine;
        r32[3,1]:=p;
        r32[3,2]:=q;
        r32[3,3]:=r;
      end;
    end;

    matinv(r32,r23,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1066');
     halt;
   end;
    mat_mult(r32,r21,r31);
    matinv(r31,r13,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1072');
     halt;
   end;
end;

procedure erreur(s:string);{
---------------------------}
begin
   //beep;
   MessageDlg(s,mtWarning,[mbOK],0);
end;

function uptrim(var s:string): string;
//----------------------------- -------
begin
  s:=trim(s);
  uptrim:=uppercase(s);
end;

//Recherche des sortes d'atomes (lments)
Procedure traite_nom_element(var s:string);
//----------------------------------------
var
  c          : char;
begin
  if (length(s) < 2)then exit;
  c:=s[2];
  if (ord(c) > 47) and (ord(c) < 58)then insert(' ',s,2);
end;

Procedure traite_nom_atome(var s:string);
//----------------------------------------
var
  s2:string;
begin
  while (pos(' ',s) > 0)do delete(s,pos(' ',s),1);
  if (length(s) > 1)then begin
    s2:=lowercase(s);
    s[2]:=s2[2];
  end;
  s:=trim(s);
end;


Procedure matrois  (var i1,i2,ier : integer);
//------------------------------------------
var
  s1,s2                     : string;
  x,y,z                     : vecteur3;
  i,j                       : integer;
  som,xx                    : double;

begin

{  wr(nomfich,'r20',r20);
  wr(nomfich,'r31',r31);
  wr(nomfich,'r20',r20);
  writeln(nomfich,'i1:',i1:2,' i2:',i2:2);}

  ier:=0;
  x[1]:=r31[i1,1];
  x[2]:=r31[i1,2];
  x[3]:=r31[i1,3];
  {writeln(nomfich,'X avant trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  trfo3(x,r20);
{  writeln(nomfich,'X aprs trfo3:',x[1]:10:5,x[2]:10:5,x[3]:10:5);  }
  norm(x[1],x[2],x[3]);
{  writeln(nomfich,'X aprs norm :',x[1]:10:5,x[2]:10:5,x[3]:10:5);}
  y[1]:=r31[i2,1];
  y[2]:=r31[i2,2];
  y[3]:=r31[i2,3];
 { writeln(nomfich,'Y avant trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);}
  trfo3(y,r20);
{  writeln(nomfich,'Y aprs trfo3:',y[1]:10:5,y[2]:10:5,y[3]:10:5);  }
  norm(y[1],y[2],y[3]);
{  writeln(nomfich,'Y aprs norm :',y[1]:10:5,y[2]:10:5,y[3]:10:5);}

{les deux vecteurs doivent tre perpendiculaires}
  som:=0;
  for  i:=1 to 3 do  som:=som+x[i]*y[i];
{  writeln(nomfich,'Produit scalaire : ',som:5:2);}
  if(som > 0.01)then begin
    str(i1:2,s1);
    str(i2:2,s2);
    {chaine:='les 2 vecteurs ne sont pas perpendiculaires';
    erreur(chaine);}
    //erreur('Error! the vectors are not perpendicular');
    ier:=1;
    exit;
  end;

  prodvec(x,y,z);
{  writeln(nomfich,'Vecteur Z avant trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}

{Changement de signe du produit vectoriel si i1+i2 est pair}
  {k:=i1+i2+1;
  xx:=(-1.)^k;}
  xx:=1;
  if((i1+i2) mod 2 =0) then xx:=-1;
  if((i1+i2) mod 2 <> 0)then xx:=1;
  for i:=1 to 3 do z[i]:=xx*z[i];

  trfo3(z,r02);
{  writeln(nomfich,'Vecteur Z aprs trfo3:',z[1]:10:5,z[2]:10:5,z[3]:10:5);}

  for i:=1 to 3 do begin
    if(i = i1) or (i = i2) then continue;
    for j:=1 to 3 do r31[i,j]:=z[j];
  end;

  {  writeln(nomfich,'Matrice avant inversion :');}
  {  wr(nomfich,'R31',r31);}
  {  closefile(nomfich);   }

  matinv(r31,r13,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1885');
     halt;
   end;
{      wr(nomfich,'r01',r01);
      wr(nomfich,'r10',r10);
      wr(nomfich,'r20',r20);
      wr(nomfich,'r02',r02);
      wr(nomfich,'r12',r12);
      wr(nomfich,'r21',r21);
      wr(nomfich,'r13',r13);
      wr(nomfich,'r31',r31);
      mat_mult(r13,r31,aux);
      wr(nomfich,'r13Xr31',aux);}

end;

procedure conditionne_matrice;
//---------------------------
var
  //som                            : double;
  ier                            : integer;
  v1,v2,v3                       : vecteur3;
  //nomf                           : textfile;
begin
  //wr(nomf,'avant correction',r13); *)
  v1[1]:=r13[1,1];
  v1[2]:=r13[2,1];
  v1[3]:=r13[3,1];
  v2[1]:=r13[1,2];
  v2[2]:=r13[2,2];
  v2[3]:=r13[3,2];
  trfo3(v1,r21);
  trfo3(v2,r21);
  prodvec(v1,v2,v3);
  prodvec(v3,v1,v2);
  trfo3(v1,r12);
  trfo3(v2,r12);
  trfo3(v3,r12);
  r13[1,1]:=v1[1];
  r13[2,1]:=v1[2];
  r13[3,1]:=v1[3];
  r13[1,2]:=v2[1];
  r13[2,2]:=v2[2];
  r13[3,2]:=v2[3];
  r13[1,3]:=v3[1];
  r13[2,3]:=v3[2];
  r13[3,3]:=v3[3];
  matinv(r13,r31,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1936');
     halt;
   end;
  mat_mult(r31,r12,r32);
  matinv(r32,r23,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1942');
     halt;
   end;
  mat_mult(r31,r10,r30);
  mat_mult(r01,r13,r03);
 // wr(nomf,'aprs correction',r13);
 // writeln(nomf,'Paramtres aprs correction');
 (* for i:=1 to 3 do begin
    som:=0;
    for j:=1 to 3 do som:=som+r13[i,j]*r13[i,j];
    som:=sqrt(som);
    writeln(nomf,som:8:4);
  end;  *)
  //closefile(nomf);
end;

{calcul de la matrice d'orientation}
Procedure calcmat(var rpqr :matrice3; var ier:integer);
//-----------------------------------------------------
var
  izero                   : array[1..3] of integer;
  nzero,i,j,i1,i2         : integer;
  som,p,q,r,dt            : double;

begin
  ier:=0;
  nzero:=0;
  for i:=1 to 3 do begin
    som:=0;
    izero[i]:=0;
    for j:=1 to 3 do som:=som+rpqr[i,j]*rpqr[i,j];
    if(som > 0.0001)then begin
      izero[i]:=1;
      nzero:=nzero+1;
    end;
  end;

  if(nzero = 1) then begin
    for i:=1 to 3 do begin
      if(izero[i] <> 0)then begin
        p:=r31[i,1];
        q:=r31[i,2];
        r:=r31[i,3];
        rot(p,q,r,i);
        mat_mult(r31,r12,r32);
        matinv(r32,r23,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 1969');
     halt;
   end;
        dt:=det(r23);
{        writeln(nomfich,'dterminant de R23 : ',dt:5:2);}
        dt:=abs(dt);
        if(dt < 0 ) or (abs(dt-1) > 0.001) then begin
          ier:=1;
          erreur(' Math error (determinant)');
        end;
        exit;
      end;
    end;
  end;

  if(nzero = 2)then begin
    for i:=1 to 3 do begin
      if(izero[i] = 1)then begin
        i1:=i;
        break;
      end;
    end;
    for i:=i1+1 to 3 do begin
      if(izero[i] = 1)then begin
        i2:=i;
        break;
      end;
    end;
    {writeln(nomfich,'i1: ',i1:2,'  i2: ',i2:2);
    writeln(nomfich,'Entre dans matrois');}
    ier:=0;
    matrois(i1,i2,ier);
    {writeln(nomfich,'Sortie de matrois');}
    if(ier = 1)then begin
      erreur('Error! The vectors are not perpendicular');
      ier:=1;
      exit;
    end;
    mat_mult(r31,r12,r32);
    matinv(r32,r23,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 2010');
     halt;
   end;
    {wr(nomfich,'R31',r31);
    wr(nomfich,'R13',r13);
    wr(nomfich,'r32',r32);
    wr(nomfich,'r23',r23); }
    dt:=det(r23);
{    writeln(nomfich,'dterminant de R23 : ',dt:5:2);}
    dt:=abs(dt);
    {writeln(nomfich,'jer:=',jer:2,' Dterminant : ',dt:5:2);}
    if(dt < 0) or (abs(dt-1) > 0.001) then begin
      erreur('Error! The vectors are not perpendicular');
      ier:=1;
      //erreur('The matrix determinant is different from 1');
    end;
    exit;
  end;
  if(nzero = 3)then begin
    mat_mult(r31,r12,r32);
    matinv(r32,r23,ier);
   if (ier > 0)then begin
     erreur('erreur dans oemath ligne 2032');
     halt;
   end;
    dt:=abs(det(r23));
    if(dt < 0) or (abs(dt-1) > 0.001)then begin
      ier:=1;
      erreur(' The matrix determinant is different from 1');
    end;
    exit;
  end;
end;
 {     calcul de la matrice connaissant deux vecteurs i1 et i2. on fait
c     le produit vectoriel pour obtenir le 3me (attention au sens!)}

procedure teste_fichier_unix(var nom:string);
//------------------------------------------
var
  sortie,esp,nomf            : TextFile;
  sv,s,se                    : string;
  fichier                    : string;
  n,i,n13                    : integer;
  b,b0                       : byte;
  boul: boolean;
begin

//Est-ce un fichier Unix?
  n13:=0;
  b0:=0;
  n:=0;

//Lecture du fichier
    AssignFile(nomf,nom);
    reset(nomf);
    fichier:='dummy.tmp';
    AssignFile(sortie,fichier);
    rewrite(sortie);
    s:='';
    while not(eof(nomf)) do begin
      readln(nomf,s);
      writeln(sortie,s);
    end;
    closefile(nomf);
    closefile(sortie);

//Re-copie et effacement
    assignfile(sortie,fichier);
    reset(sortie);
    assignfile(esp,nom);
    rewrite(esp);
    while not(eof(sortie)) do begin
      readln(sortie,s);
      writeln(esp,s);
    end;
    closefile(sortie);
    closefile(esp);
    deletefile('dummy.tmp');
end;

procedure attribue_couleur;
//-------------------------
var
  i,iat                                           : integer;
  s2,s22                                          : string[2];
  s                                               : string;
  //nomf : textfile;
begin
 for iat:=1 to nb_child do begin
   if (child[iat].element = 'DU')then continue;
   child[iat].couleur:=0;
   //s2:=copy(child[iat].nom,1,2);
   //s2:=trim(s2); s2:=uppercase(s2);
   s:=child[iat].element;
   s2:=uptrim(s);
   for i:=1 to nb_typ_element do begin
     s22:=element[i].nom;s22:=trim(s22);s22:=uppercase(s22);
     if (s2 = s22)then begin
       child[iat].couleur:=element[i].couleur;
       break;
     end;
   end;
   if (child[iat].couleur = 0)then child[iat].couleur:=clwhite;
 end;
end;

procedure quel_systeme;
//---------------------
var
  dif1,dif2,dif3          : double;
begin
 dif1:=abs(cel[1]-cel[2]);
 dif2:=abs(cel[2]-cel[3]);
 dif3:=abs(cel[3]-cel[1]);
 if (cel[4] = 90) and (cel[5] = 90) and (cel[6] = 90)then begin
   if (dif1 < 0.001) and (dif2 < 0.001) and (dif3 < 0.001)then begin
     systeme:='CUBI';
     exit;
   end;
   if (dif1 < 0.001) and (dif2 > 0.001) then begin
     systeme:='TETR';
     exit;
   end;
   if (dif1 > 0.001) and (dif2 > 0.001) then begin
     systeme:='ORTH';
     exit;
   end;
 end else if (cel[4] = 90) and (cel[5] = 90) and (cel[6] = 120)then begin
   systeme:='HEXA';
   exit;
 end else if (dif1 < 0.001) and (dif2 < 0.001) and (dif3 < 0.001) then begin
   systeme:='RHOM';
   exit;
 end else if (cel[4] = 90) and (cel[5] <> 90) and (cel[6] = 90)then begin
   systeme:='MONO';
   exit;
 end else if (cel[4] = 90) and (cel[5] = 90) and (cel[6] <> 90)then begin
   systeme:='MONO';
   exit;
 end else if (cel[4] = 90) and (cel[5] = 90) and (cel[6] <> 90)then begin
   systeme:='MONO';
   exit;
 end else begin
   systeme:='TRIC';
   exit;
 end;

end;

{Guerrit les .0 0. et -.}
procedure verif(var s:string);{
------------------------------}
var
  n         :integer;
begin
  if (s = '')then begin
    s:='0';
    exit;
  end;
  n:=pos(' .',s);
  if(n < 0)then s[n]:='0';
  n:=pos('. ',s);
  if(n > 0)then s[n+1]:='0';
  n:=pos('-.',s);
  if(n > 0)then insert('0',s,n+1);
  n:=length(s);
  if(s[n] = '.') then s:=s+'0';
end;

procedure teste_matrice_beta(var bet:matrice3; var ier:integer);
//------------------------------------------------------------------
(*var
  i,j        : integer; *)
begin
        ier:=0;
        if (bet[1,1]*bet[2,2]-sqr(bet[1,2]) < 0)or
           (bet[1,1]*bet[3,3]-sqr(bet[1,3]) < 0)or
           (bet[3,3]*bet[2,2]-sqr(bet[2,3]) < 0)or
           (bet[1,1]*bet[2,2]*bet[3,3]+2*bet[1,2]*bet[1,3]*bet[2,3]-
           bet[1,1]*bet[2,3]*bet[2,3]-
           bet[2,2]*bet[1,3]*bet[1,3]-
           bet[3,3]*bet[1,2]*bet[1,2]        < 0)then ier:=1;
end;

end.
